# SymEngine.jl

[![Build Status](https://github.com/symengine/SymEngine.jl/workflows/CI/badge.svg)](https://github.com/symengine/SymEngine.jl/actions)
[![Build status](https://ci.appveyor.com/api/projects/status/github/symengine/symengine.rb?branch=master&svg=true)](https://ci.appveyor.com/project/isuruf/symengine-jl-pj80f/branch/master)
[![Codecov](http://codecov.io/github/symengine/SymEngine.jl/coverage.svg?branch=master)](http://codecov.io/github/symengine/SymEngine.jl?branch=master)
[![Coveralls](https://coveralls.io/repos/symengine/SymEngine.jl/badge.svg?branch=master&service=github)](https://coveralls.io/github/symengine/SymEngine.jl?branch=master)
[![Documentation](https://img.shields.io/badge/docs-blue.svg)](https://symengine.org/SymEngine.jl)

Julia Wrappers for [SymEngine](https://github.com/symengine/symengine), a fast symbolic manipulation library, written in C++.

## Installation

You can install `SymEngine.jl` by giving the following command.

```julia
julia> Pkg.add("SymEngine")
```

## Quick Start

### Working with scalar variables

#### Defining variables

One can define variables in a few ways. The following three examples are equivalent.

Defining two symbolic variables with the names `a` and `b`, and assigning them to julia variables with the same name.

``` julia
julia> a=symbols(:a); b=symbols(:b)
b

julia> a,b = symbols("a b")
(a, b)

julia> @vars a b
(a, b)
```

### Simple expressions

We are going to define an expression using the variables from earlier:

``` julia
julia> ex1 = a + 2(b+2)^2 + 2a + 3(a+1)
3*a + 3*(1 + a) + 2*(2 + b)^2
```

One can see that values are grouped, but no expansion is done.

### Working with vector and matrix variables

### Defining vectors of variables

A vector of variables can be defined using list comprehension and string interpolation.

```julia
julia> [symbols("α_$i") for i in 1:3]
3-element Vector{Basic}:
 α_1
 α_2
 α_3
```

#### Defining matrices of variables

Some times one might want to define a matrix of variables.
One can use a matrix comprehension, and string interpolation to create a matrix of variables.

```julia
julia> W = [symbols("W_$i$j") for i in 1:3, j in 1:4]
3×4 Matrix{Basic}:
 W_11  W_12  W_13  W_14
 W_21  W_22  W_23  W_24
 W_31  W_32  W_33  W_34
```

#### Matrix-vector multiplication

Now using the matrix we can perform matrix operations:

```julia
julia> W*[1.0, 2.0, 3.0, 4.0]
3-element Vector{Basic}:
 1.0*W_11 + 2.0*W_12 + 3.0*W_13 + 4.0*W_14
 1.0*W_21 + 2.0*W_22 + 3.0*W_23 + 4.0*W_24
 1.0*W_31 + 2.0*W_32 + 3.0*W_33 + 4.0*W_34
```

### Operations

#### `expand`

```julia
julia> expand(a + 2(b+2)^2 + 2a + 3(a+1))
11 + 6*a + 8*b + 2*b^2
```

#### `subs`

Performs substitution.

```julia
julia> subs(a^2+(b-2)^2, b=>a)
a^2 + (-2 + a)^2

julia> subs(a^2+(b-2)^2, b=>2)
a^2

julia> subs(a^2+(b-2)^2, a=>2)
4 + (-2 + b)^2

julia> subs(a^2+(b-2)^2, a^2=>2)
2 + (-2 + b)^2

julia> subs(a^2+(b-2)^2, a=>2, b=>3)
5
```

#### `diff`

Peforms differentiation

```julia
julia> diff(a + 2(b+2)^2 + 2a + 3(a+1), b)
4*(2 + b)
```

## License

`SymEngine.jl` is licensed under MIT open source license.

@inline function throw_if_error(error_code::Cuint, str=nothing)
    if error_code == 0
        return
    else
        throw(get_error(error_code, str))
    end
end

function get_error(error_code::Cuint, str=nothing)
    if error_code == 1
        return ErrorException("Unknown SymEngine Exception")
    elseif error_code == 2
        return DivideError()
    elseif error_code == 3
        return ErrorException("Not implemented SymEngine feature")
    elseif error_code == 4
        return DomainError(str)
    elseif error_code == 5
        return Meta.ParseError(str)
    else
        return ErrorException("Unexpected SymEngine error code")
    end
end

module SymEngine

using SymEngine_jll

import Base: show, convert, real, imag, MathConstants.γ, MathConstants.e, MathConstants.φ, MathConstants.catalan, invokelatest
import Compat: String, unsafe_string, @compat, denominator, numerator, Cvoid, Nothing, finalizer, reduce, mapreduce
import Serialization
import LinearAlgebra, Libdl

export Basic, symbols, @vars, @funs, SymFunction
export free_symbols, function_symbols, get_name, get_args
export coeff
export ascii_art
export subs, lambdify, N, cse
export series
export expand

include("utils.jl")
const have_mpfr = have_component("mpfr")
const have_mpc = have_component("mpc")
const libversion = get_libversion()

include("exceptions.jl")
include("ctypes.jl")
include("types.jl")
include("decl.jl")
include("display.jl")
include("mathops.jl")
include("mathfuns.jl")
include("simplify.jl")
include("subs.jl")
include("numerics.jl")
include("calculus.jl")
include("recipes.jl")
include("dense-matrix.jl")

function __init__()
    init_constants()
end

end

using Test
using SymEngine

import TermInterface
@testset "TermInterface" begin
    @vars x, ∫()
    @test !TermInterface.iscall(x)
    @test TermInterface.iscall(x^2)
    @test TermInterface.operation(sin(x)) == sin
    @test TermInterface.arguments(sin(x)) == [x]
    @test nameof(TermInterface.operation(∫(sin(x), x))) == nameof(∫)
end

#=
import SymbolicUtils: simplify, @rule, @acrule, Chain, Fixpoint
@testset "SymbolicUtils" begin
    # from SymbolicUtils.jl docs
    # https://symbolicutils.juliasymbolics.org/rewrite/#rule-based_rewriting
    @vars w x y z
    @vars α β
    @vars a b c d

    @test simplify(cos(x)^2 + sin(x)^2) == 1

    r1 = @rule sin(2(~x)) => 2sin(~x)*cos(~x)
    @test r1(sin(2z)) == 2*cos(z)*sin(z)
    @test r1(sin(3z)) === nothing
    @test r1(sin(2*(w-z))) == 2cos(w - z)*sin(w - z)
    @test r1(sin(2*(w+z)*(α+β))) === nothing

    r2 = @rule sin(~x + ~y) => sin(~x)*cos(~y) + cos(~x)*sin(~y);
    @test r2(sin(α+β)) == sin(α)*cos(β) + cos(α)*sin(β)

    xs = @rule(+(~~xs) => ~~xs)(x + y + z) # segment variable
    @test Set(xs) == Set([x,y,z])

    r3 = @rule ~x * +(~~ys) => sum(map(y-> ~x * y, ~~ys));
    @test r3(2 * (w+w+α+β)) == 4w + 2α + 2β

    r4 = @rule ~x + ~~y::(ys->iseven(length(ys))) => "odd terms"; # Predicates for matching

    @test r4(a + b + c + d) == nothing
    @test r4(b + c + d) == "odd terms"
    @test r4(b + c + b) == nothing
    @test r4(a + b) == nothing

    sqexpand = @rule (~x + ~y)^2 => (~x)^2 + (~y)^2 + 2 * ~x * ~y
    @test sqexpand((cos(x) + sin(x))^2) == cos(x)^2 + sin(x)^2 + 2cos(x)*sin(x)

    pyid = @rule  sin(~x)^2 + cos(~x)^2  => 1
    @test_broken pyid(cos(x)^2 + sin(x)^2) === nothing  # order should matter, but this works

    acpyid = @acrule sin(~x)^2 + cos(~x)^2 => 1 # acrule is commutative
    @test acpyid(cos(x)^2 + sin(x)^2 + 2cos(x)*sin(x)) == 1 + 2cos(x)*sin(x)

    csa = Chain([sqexpand, acpyid]) # chain composes rules
    @test csa((cos(x) + sin(x))^2)  == 1 + 2cos(x)*sin(x)

    cas = Chain([acpyid, sqexpand]) # order matters
    @test cas((cos(x) + sin(x))^2) == cos(x)^2 + sin(x)^2 + 2cos(x)*sin(x)

    @test Fixpoint(cas)((cos(x) + sin(x))^2) == 1 + 2cos(x)*sin(x)

end
=#

using Pkg
Pkg.activate(".")
using SymEngine

struct CustomFunc
    name::String
    cfunc::Base.CFunction
    func1
    func2
end

struct CFunctionWrapperClass
    name::Ptr{Cchar}
    create_ptr::Ptr{Cvoid}
    diff_ptr::Ptr{Cvoid}
end

function create_func(name, f)
    function _create_func(a::Basic, args_ptr::Ptr{Cvoid})::Cint
        args = SymEngine.CVecBasic(args_ptr)
        try
            res = f(convert(Vector, args))
        catch e
            res = nothing
        end
        if res == nothing
            return 1
        else
            res = Basic(res)
            ccall((:basic_assign, SymEngine.libsymengine), Nothing, (Ref{Basic}, Ref{Basic}), a, res)
            return 0
        end
    end
    create_ptr = @cfunction($_create_func, Cint, (Ref{Basic}, Ptr{Cvoid}))
    return CustomFunc(name, create_ptr, f, _create_func)
end

function my_real(x::Vector{Basic})
   return real(N(x[1]))
end

function my_norm(x::Vector{Basic})
   a, b = N(x[1]), N(x[2])
   return sqrt(a^2+b^2)
end

@vars x

function (c::CustomFunc)(args...)
    v = convert(SymEngine.CVecBasic, args...)
    a = Basic()
    ccall((:basic_create_function_wrapper, SymEngine.libsymengine), Nothing, (Ref{Basic}, Ptr{Cvoid}, Cstring, Ptr{Cvoid}, Ptr{Cvoid}), a, v.ptr, pointer(c.name), c.cfunc.ptr, C_NULL)
    return a
end

c = create_func("Re", my_real)
c(x)

d = create_func("Norm", my_norm)
d(2, 3)

IMPLEMENT_ONE_ARG_FUNC(nothing, :expand, :expand)

if get_symbol(:basic_cse) != C_NULL
    function cse(exprs...)
        vec = convert(CVecBasic, exprs...)
        replacement_syms = CVecBasic()
        replacement_exprs = CVecBasic()
        reduced_exprs = CVecBasic()
        ccall((:basic_cse, libsymengine), Nothing, (Ptr{Cvoid},Ptr{Cvoid},Ptr{Cvoid},Ptr{Cvoid}),
            replacement_syms.ptr, replacement_exprs.ptr, reduced_exprs.ptr,vec.ptr)
        return replacement_syms, replacement_exprs, reduced_exprs
    end
else
    function cse(exprs...)
        error("libsymengine is too old")
    end
end

using RecipesBase

## Plug into RecipesBase so plots of expressions treated like plots of functions
@recipe f(::Type{T}, v::T) where {T<:Basic} = lambdify(v)
@recipe f(::Type{S}, ss::S) where {S<:AbstractVector{Basic}} = Function[lambdify(s) for s in ss]

"""
    get_symbol(sym)

Helper function to lookup a symbol from libsymengine
"""
function get_symbol(sym::Symbol)
    handle = Libdl.dlopen_e(libsymengine)
    if handle == C_NULL
        C_NULL
    else
        Libdl.dlsym_e(handle, sym)
    end
end

"""
    get_libversion()

Get libsymengine version
"""
function get_libversion()
    func = get_symbol(:symengine_version)
    if func != C_NULL
        a = ccall(func, Ptr{UInt8}, ())
        VersionNumber(unsafe_string(a))
    else
        # Above method is not in 0.2.0 which is the earliest version supported
        VersionNumber("0.2.0")
    end
end

"""
    have_component(comp::String)

Check whether libsymengine was compiled with component `comp`
"""
function have_component(comp::String)
    func = get_symbol(:symengine_have_component)
    if func != C_NULL
        ccall(func, Cint, (Ptr{UInt8},), comp) == 1
    elseif comp == "mpfr"
        get_symbol(:real_mpfr_set_d) != C_NULL
    elseif comp == "mpc"
        get_symbol(:complex_mpc_real_part) != C_NULL
    else
        false
    end
end

# test for allocations
@vars x y
a = Basic()
@testset "non-allocating(ish) methods" begin
    sin(x), cos(x), abs(x)
    x^x, x + x, x*x, x-x, x/x # warm up

    @test (@allocations SymEngine.sin!(a,x)) == 0
    @test (@allocations SymEngine.cos!(a,x)) == 0
    @test (@allocations SymEngine.pow!(a,x,x)) == 0

    # still allocates 1 (or 2)
    @test (@allocations SymEngine.add!(a,x,y)) < (@allocations x+y)
    @test (@allocations SymEngine.sub!(a,x,y)) < (@allocations x-y)
    @test (@allocations SymEngine.mul!(a,x,y)) < (@allocations x*y)
    @test (@allocations SymEngine.div!(a,x,y)) < (@allocations x/y)
    @test (@allocations SymEngine.abs2!(a,x)) < (@allocations abs2(x))
end

module SymEngineTermInterfaceExt

import SymEngine
import TermInterface


λ(x::SymEngine.SymbolicType) = λ(Val(SymEngine.get_symengine_class(x)))
λ(::Val{T}) where {T} = getfield(Main, Symbol(lowercase(string(T))))

λ(::Val{:Add}) = +; λ(::Val{:Sub}) = -
λ(::Val{:Mul}) = *; λ(::Val{:Div}) = /
λ(::Val{:Pow}) = ^
λ(::Val{:re}) = real; λ(::Val{:im}) = imag
λ(::Val{:Abs}) = abs
λ(::Val{:Log}) = log
λ(::Val{:Sin}) = sin; λ(::Val{:Cos}) = cos; λ(::Val{:Tan}) = tan
λ(::Val{:Csc}) = csc; λ(::Val{:Sec}) = sec; λ(::Val{:Cot}) = cot
λ(::Val{:Asin}) = asin; λ(::Val{:Acos}) = acos; λ(::Val{:Atan}) = atan
λ(::Val{:Acsc}) = acsc; λ(::Val{:Asec}) = asec; λ(::Val{:Acot}) = acot
λ(::Val{:Sinh}) = sinh; λ(::Val{:Cosh}) = cosh; λ(::Val{:Tanh}) = tanh
λ(::Val{:Csch}) = csch; λ(::Val{:Sech}) = sech; λ(::Val{:Coth}) = coth
λ(::Val{:Asinh}) = asinh; λ(::Val{:Acosh}) = acosh; λ(::Val{:Atanh}) = atanh
λ(::Val{:Acsch}) = acsch; λ(::Val{:Asech}) = asech; λ(::Val{:Acoth}) = acoth
λ(::Val{:ATan2}) = atan;
λ(::Val{:Beta}) = SymEngine.SpecialFunctions.beta;
λ(::Val{:Gamma}) = SymEngine.SpecialFunctions.gamma;
λ(::Val{:PolyGamma}) = SymEngine.SpecialFunctions.polygamma;
λ(::Val{:LogGamma}) = SymEngine.SpecialFunctions.loggamma;
λ(::Val{:Erf}) = SymEngine.SpecialFunctions.erf;
λ(::Val{:Erfc}) = SymEngine.SpecialFunctions.erfc;
λ(::Val{:Zeta}) = SymEngine.SpecialFunctions.zeta;
λ(::Val{:LambertW}) = SymEngine.SpecialFunctions.lambertw



const julia_operations = Vector{Any}(missing, length(SymEngine.symengine_classes))
for (i,s) ∈ enumerate(SymEngine.symengine_classes)
    val = try
        λ(Val(s))
    catch err
        missing
    end
    julia_operations[i] = val
end

#==
Check if x represents an expression tree. If returns true, it will be assumed that operation(::T) and arguments(::T) methods are defined. Definining these three should allow use of SymbolicUtils.simplify on custom types. Optionally symtype(x) can be defined to return the expected type of the symbolic expression.
==#
function TermInterface.iscall(x::SymEngine.SymbolicType)
    cls = SymEngine.get_symengine_class(x)
    cls == :Symbol && return false
    cls == :Constant && return false
    any(==(cls), SymEngine.number_types) && return false
    return true
end
TermInterface.isexpr(x::SymEngine.SymbolicType) = TermInterface.iscall(x)

##TermInterface.issym(x::SymEngine.SymbolicType) = SymEngine.get_symengine_class(x) == :Symbol

TermInterface.operation(x::SymEngine.SymFunction) = x
function TermInterface.operation(x::SymEngine.SymbolicType)
    TermInterface.iscall(x) || error("Not a call.")
    fn = julia_operations[SymEngine.get_type(x) + 1]
    if ismissing(fn) && SymEngine.get_julia_class(x) == :functionsymbol
        fn = SymEngine.SymFunction(Symbol(SymEngine.get_name(x)))
    end
    fn
end

function TermInterface.arguments(x::SymEngine.SymbolicType)
    SymEngine.get_args(x)
end

TermInterface.head(x::SymEngine.SymbolicType) = TermInterface.operation(x)
TermInterface.children(x::SymEngine.SymbolicType) = TermInterface.arguments(x)

function TermInterface.maketerm(t::Type{<:SymEngine.SymbolicType}, f, args,
                                metadata=nothing)
    f(args...) # default
end


# no metadata(x), metadata(x, data)

end

function toString(b::SymbolicType)
    b = Basic(b)
    if b.ptr == C_NULL
        return "<Unitialized Basic value>"
    end
    a = ccall((:basic_str_julia, libsymengine), Cstring, (Ref{Basic}, ), b)
    string = unsafe_string(a)
    ccall((:basic_str_free, libsymengine), Nothing, (Cstring, ), a)
    return string
end

Base.show(io::IO, b::SymbolicType) = print(io, toString(b))


" show symengine logo "
mutable struct AsciiArt x end
function ascii_art()
    out = ccall((:ascii_art_str, libsymengine),  Ptr{UInt8},  ())
    AsciiArt(unsafe_string(out))
end

Base.show(io::IO, x::AsciiArt) = print(io, x.x)

"""
    subs(ex, var, val)
    subs(ex, d::AbstractDict)
    subs(ex, y::Tuple)
    subs(ex)

Substitute values into a symbolic expression.

### Examples

```julia
@vars x y
ex = x^2 + y^2
subs(ex, x, 1) # 1 + y^2
subs(ex, (x, 1)) # 1 + y^2
subs(ex, (x, 1), (y,x)) # 1 + x^2, values are substituted left to right.
subs(ex, x=>1)  # alternate to subs(x, (x,1))
subs(ex, x=>1, y=>1) # ditto
```
"""
function subs(ex::T, var::S, val) where {T<:SymbolicType, S<:SymbolicType}
    s = Basic()
    subs!(s, ex, var, val)
end

function subs!(s::Basic, ex::T, var::S, val) where {T<:SymbolicType, S<:SymbolicType}
    err_code = ccall((:basic_subs2, libsymengine), Cuint, (Ref{Basic}, Ref{Basic}, Ref{Basic}, Ref{Basic}), s, ex, var, val)
    throw_if_error(err_code, ex)
    return s
end

function subs(ex::T, d::CMapBasicBasic) where T<:SymbolicType
    s = Basic()
    subs!(s, ex, d)
end
function subs!(s::Basic, ex::T, d::CMapBasicBasic) where T<:SymbolicType
    err_code = ccall((:basic_subs, libsymengine), Cuint, (Ref{Basic}, Ref{Basic}, Ptr{Cvoid}), s, ex, d.ptr)
    throw_if_error(err_code, ex)
    return s
end


subs(ex::T, d::AbstractDict) where {T<:SymbolicType} = subs(ex, CMapBasicBasic(d))
subs(ex::T, y::Tuple{S, Any}) where {T <: SymbolicType, S<:SymbolicType} = subs(ex, y[1], y[2])
subs(ex::T, y::Tuple{S, Any}, args...) where {T <: SymbolicType, S<:SymbolicType} = subs(subs(ex, y), args...)
subs(ex::T, d::Pair...) where {T <: SymbolicType} = subs(ex, [(p.first, p.second) for p in d]...)
subs(ex::SymbolicType) = ex

## Allow an expression to be called, as with ex(2). When there is more than one symbol, one can rely on order of `free_symbols` or
## be explicit by passing in pairs : `ex(x=>1, y=>2)` or a dict `ex(Dict(x=>1, y=>2))`.
function (ex::Basic)(args...)
    xs = free_symbols(ex)
    isempty(xs) && return ex
    subs(ex, collect(zip(xs, args))...)
end
(ex::Basic)(x::AbstractDict) = subs(ex, x)
(ex::Basic)(x::Pair, xs::Pair...) = subs(ex, x, xs...)


## Lambdify

## Map symengine classes to function names
fn_map = Dict(
              :Add => :+,
              :Sub => :-,
              :Mul => :*,
              :Div => :/,
              :Pow => :^,
              :re  => :real,
              :im  => :imag,
              :Abs => :abs # not really needed as default in map_fn covers this
              )

map_fn(key, fn_map) = haskey(fn_map, key) ? fn_map[key] : Symbol(lowercase(string(key)))

const julia_classes = map_fn.(symengine_classes, (fn_map,))
get_julia_class(x::Basic) = julia_classes[get_type(x) + 1]
get_julia_class(x::SymFunction) = Symbol(x)

#_convert(::Type{Expr}, ex::SymFunction) = Symbol(ex)
function _convert(::Type{Expr}, ex::Basic)
    fn = get_symengine_class(ex)

    if fn ∈ (:Symbol,)
        return Symbol(ex)
    elseif (fn in number_types) || (fn == :Constant)
        return N(ex)
    end
    fn′ = get_julia_class(ex)

    if fn′ === :functionsymbol
        fn′ = Symbol(get_name(ex))
    end

    as = get_args(ex)
    Expr(:call, fn′, (_convert(Expr,a) for a in as)...)
end

function convert(::Type{Expr}, ex::Basic)
    fn = get_symengine_class(ex)

    if fn == :Symbol
        return Expr(:call, :*, Symbol(ex), 1)
    elseif (fn in number_types) || (fn == :Constant)
        return Expr(:call, :*, N(ex), 1)
    end

    return _convert(Expr, ex)
end

function convert(::Type{Expr}, m::AbstractArray{Basic, 2})
    col_args = []
    for i = 1:size(m, 1)
        row_args = []
        for j = 1:size(m, 2)
            push!(row_args, convert(Expr, m[i, j]))
        end
        row = Expr(:hcat, row_args...)
        push!(col_args, row)
    end
    Expr(:vcat, col_args...)
end

function convert(::Type{Expr}, m::AbstractArray{Basic, 1})
    row_args = []
    for j = 1:size(m, 1)
        push!(row_args, convert(Expr, m[j]))
    end
    Expr(:vcat, row_args...)
end

walk_expression(b) = convert(Expr, b)

"""
    lambdify(ex, vars=[]; cse=false)

Evaluates a symbol-less expression or returns a function
"""
function lambdify(ex, vars=[])
    if length(vars) == 0
        vars = free_symbols(ex)
    end
    body = convert(Expr, ex)
    lambdify(body, vars)
end

function lambdify(ex::Basic, vars=[]; cse=false)
    if length(vars) == 0
        vars = free_symbols(ex)
    end
    if !cse
        body = convert(Expr, ex)
        return lambdify(body, vars)
    end
    replace_syms, replace_exprs, new_exprs = SymEngine.cse(ex)
    body_args = []
    for (i, j) in zip(replace_syms, replace_exprs)
        append!(body_args, [Expr(:(=), Symbol(toString(i)), convert(Expr, j))])
    end
    append!(body_args, [convert(Expr, new_exprs[0])])
    body = Expr(:block, body_args...)
    lambdify(body, vars)
end

lambdify(ex::BasicType, vars=[]) = lambdify(Basic(ex), vars)

function lambdify(ex::Expr, vars)
    if length(vars) == 0
        # return a number
        eval(ex)
    else
        # return a function
        _lambdify(ex, vars)
    end
end

function _lambdify(ex::Expr, vars)
    try
        fn = eval(Expr(:function,
                       Expr(:call, gensym(), map(Symbol,vars)...),
                       ex))
        (args...) -> invokelatest(fn, args...) # https://github.com/JuliaLang/julia/pull/19784
    catch err
        throw(ArgumentError("Expression does not lambdify"))
    end
end

using SpecialFunctions

function IMPLEMENT_ONE_ARG_FUNC(modu, meth, symnm; lib=:basic_)
    methbang = Symbol(meth, "!")
    if isa(modu, Symbol)
        meth = :($modu.$meth)
    end
     @eval begin
        function ($meth)(b::SymbolicType)
            a = Basic()
            ($methbang)(a,b)
            a
        end
        function ($methbang)(a::Basic, b::SymbolicType)
            err_code = ccall(($(string(lib,symnm)), libsymengine), Cuint, (Ref{Basic}, Ref{Basic}), a, b)
            throw_if_error(err_code, $(string(meth)))
            return a
        end
    end
end

function IMPLEMENT_TWO_ARG_FUNC(modu, meth, symnm; lib=:basic_)
    methbang = Symbol(meth, "!")
    if isa(modu, Symbol)
        meth = :($modu.$meth)
    end

     @eval begin
        function ($meth)(b1::SymbolicType, b2::Number)
            a = Basic()
            ($methbang)(a,b1,b2)
            a
        end
         function ($methbang)(a::Basic, b1::SymbolicType, b2::Number)
            b1, b2 = promote(b1, b2)
            err_code = ccall(($(string(lib,symnm)), libsymengine), Cuint, (Ref{Basic}, Ref{Basic}, Ref{Basic}), a, b1, b2)
            throw_if_error(err_code, $(string(meth)))
            return a
        end

    end
end

## import from base one argument functions
## these are from cwrapper.cpp, one arg func
for (meth, libnm, modu) in [
                      (:abs,:abs,:Base),
                      (:sin,:sin,:Base),
                      (:cos,:cos,:Base),
                      (:tan,:tan,:Base),
                      (:csc,:csc,:Base),
                      (:sec,:sec,:Base),
                      (:cot,:cot,:Base),
                      (:asin,:asin,:Base),
                      (:acos,:acos,:Base),
                      (:asec,:asec,:Base),
                      (:acsc,:acsc,:Base),
                      (:atan,:atan,:Base),
                      (:acot,:acot,:Base),
                      (:sinh,:sinh,:Base),
                      (:cosh,:cosh,:Base),
                      (:tanh,:tanh,:Base),
                      (:csch,:csch,:Base),
                      (:sech,:sech,:Base),
                      (:coth,:coth,:Base),
                      (:asinh,:asinh,:Base),
                      (:acosh,:acosh,:Base),
                      (:asech,:asech,:Base),
                      (:acsch,:acsch,:Base),
                      (:atanh,:atanh,:Base),
                      (:acoth,:acoth,:Base),
                      (:log,:log,:Base),
                      (:sqrt,:sqrt,:Base),
                      (:exp,:exp,:Base),
                      (:sign, :sign, :Base),
                      (:ceil, :ceiling, :Base),
                      (:floor, :floor, :Base)
                      ]
    eval(:(import $modu.$meth))
    IMPLEMENT_ONE_ARG_FUNC(modu, meth, libnm)
end

for (meth, libnm, modu) in [
    (:gamma,:gamma,:SpecialFunctions),
    (:loggamma,:loggamma,:SpecialFunctions),
    (:eta,:dirichlet_eta,:SpecialFunctions),
    (:zeta,:zeta,:SpecialFunctions),
    (:erf, :erf, :SpecialFunctions),
    (:erfc, :erfc, :SpecialFunctions)
]
    eval(:(import $modu.$meth))
    IMPLEMENT_ONE_ARG_FUNC(modu, meth, libnm)
end

for (meth, libnm, modu) in [
    (:beta, :beta, :SpecialFunctions),
    (:polygamma, :polygamma, :SpecialFunctions),
    (:loggamma,:loggamma,:SpecialFunctions),
    ]
    eval(:(import $modu.$meth))
    IMPLEMENT_TWO_ARG_FUNC(modu, meth, libnm)
end

function abs2!(a::Basic, x::Basic)
    abs!(a, x)
    mul!(a, a, a)
    a
end
function Base.abs2(x::Basic)
    a = Basic()
    abs2!(a, x)
    a
end


if get_symbol(:basic_atan2) != C_NULL
    import Base.atan
    IMPLEMENT_TWO_ARG_FUNC(:Base, :atan, :atan2)
end

# export not import
for  (meth, libnm) in [
                       (:lambertw,:lambertw),   # in add-on packages, not base
                       ]
    IMPLEMENT_ONE_ARG_FUNC(nothing, meth, libnm)
    eval(Expr(:export, meth))
end

## add these in until they are wrapped
Base.cbrt(a::SymbolicType) = a^(1//3)

for (meth, fn) in [(:sind, :sin), (:cosd, :cos), (:tand, :tan), (:secd, :sec), (:cscd, :csc), (:cotd, :cot)]
    eval(:(import Base.$meth))
    @eval begin
        $(meth)(a::SymbolicType) = $(fn)(a*PI/180)
    end
end


## Number theory module from cppwrapper
for (meth, libnm) in [(:gcd, :gcd),
                      (:lcm, :lcm),
                      (:div, :quotient),
                      (:mod, :mod_f),
                      ]
    eval(:(import Base.$meth))
    IMPLEMENT_TWO_ARG_FUNC(:Base, meth, libnm; lib=:ntheory_)
end

Base.binomial(n::Basic, k::Number) = binomial(N(n), N(k))  #ntheory_binomial seems wrong
Base.binomial(n::Basic, k::Integer) = binomial(N(n), N(k))  #Fix dispatch ambiguity / MethodError
Base.rem(a::SymbolicType, b::SymbolicType) = a - (a ÷ b) * b
Base.factorial(n::SymbolicType, k) = factorial(N(n), N(k))

## but not (:fibonacci,:fibonacci), (:lucas, :lucas) (Basic type is not the signature)
for (meth, libnm) in [(:nextprime,:nextprime)
                      ]
    IMPLEMENT_ONE_ARG_FUNC(nothing, meth, libnm, lib=:ntheory_)
    eval(Expr(:export, meth))
end

"""
    coeff!(a, b, x, n)

Return coefficient of `x^n` term, `x` a symbol
"""
function coeff!(a::Basic, b::Basic, x, n)
    out = ccall((:basic_coeff, libsymengine), Nothing,
                (Ref{Basic},Ref{Basic},Ref{Basic},Ref{Basic}),
                a,b,Basic(x), Basic(n))
    a
end
coeff(b::Basic, x, n) = coeff!(Basic(), b, x, n)

function Base.convert(::Type{CVecBasic}, x::Vector{T}) where T
    vec = CVecBasic()
    for i in x
       b::Basic = Basic(i)
       ccall((:vecbasic_push_back, libsymengine), Nothing, (Ptr{Cvoid}, Ref{Basic}), vec.ptr, b)
    end
    return vec
end

Base.convert(::Type{CVecBasic}, x...) = Base.convert(CVecBasic, collect(promote(x...)))
Base.convert(::Type{CVecBasic}, x::CVecBasic) = x

mutable struct SymFunction
    name::String
end

SymFunction(s::Symbol) = SymFunction(string(s))
Base.Symbol(s::SymFunction) = Symbol(s.name)
Base.nameof(s::SymFunction) = Symbol(s.name)

function (f::SymFunction)(x::CVecBasic)
    a = Basic()
    ccall((:function_symbol_set, libsymengine), Nothing, (Ref{Basic}, Ptr{Int8}, Ptr{Cvoid}), a, f.name, x.ptr)
    return a
end

(f::SymFunction)(x::Vector{T}) where {T} = (f::SymFunction)(convert(CVecBasic, x))
(f::SymFunction)(x...) = (f::SymFunction)(convert(CVecBasic, x...))

macro funs(x...)
    q=Expr(:block)
    if length(x) == 1 && isa(x[1],Expr)
        @assert x[1].head === :tuple "@funs expected a list of symbols"
        x = x[1].args
    end
    for s in x
        @assert isa(s,Symbol) "@funs expected a list of symbols"
        push!(q.args, Expr(:(=), esc(s), Expr(:call, :(SymEngine.SymFunction), Expr(:quote, s))))
    end
    push!(q.args, Expr(:tuple, map(esc, x)...))
    q
end

import Base: convert, real, imag, float, eps, conj
import Base: isfinite, isnan, isinf, isless
import Base: trunc, ceil, floor, round


function evalf(b::Basic, bits::Integer=53, real::Bool=false)
    (b == oo || b == zoo || b == NAN) && return b
    c = Basic()
    bits > 53 && real && (have_mpfr || throw(ArgumentError("libsymengine has to be compiled with MPFR for this feature")))
    bits > 53 && !real && (have_mpc || throw(ArgumentError("libsymengine has to be compiled with MPC for this feature")))
    status = ccall((:basic_evalf, libsymengine), Cint, (Ref{Basic}, Ref{Basic}, Culong, Cint), c, b, Culong(bits), Int(real))
    if status == 0
        return c
    else
        throw(ArgumentError("symbolic value cannot be evaluated to a numeric value"))
    end
end

## Conversions from SymEngine.Basic -> Julia at the ccall level
function _convert(::Type{BigInt}, b::Basic)
    a = BigInt()
    _convert_bigint!(a, b)
    return a
end

function _convert_bigint!(a::BigInt, b::Basic) # non-allocating (sometimes)
    is_a_Integer(b) || throw(ArgumentError("Not an integer"))
    ccall((:integer_get_mpz, libsymengine), Nothing, (Ref{BigInt}, Ref{Basic}), a, b)
    a
end

function _convert(::Type{Int}, b::Basic)
    is_a_Integer(b) || throw(ArgumentError("Not an integer"))
    ccall((:integer_get_si, libsymengine), Int, (Ref{Basic},), b)
end

function _convert(::Type{BigFloat}, b::Basic)
    a = BigFloat()
    _convert_bigfloat!(a, b)
    return a
end

function _convert_bigfloat!(a::BigFloat, b::Basic) # non-allocating
    is_a_RealMPFR(b) || throw("Not a big value")
    ccall((:real_mpfr_get, libsymengine), Nothing, (Ref{BigFloat}, Ref{Basic}), a, b)
    a
end

function _convert(::Type{Cdouble}, b::Basic)
    is_a_RealDouble(b) || throw(ArgumentError("Not a real double"))
    return ccall((:real_double_get_d, libsymengine), Cdouble, (Ref{Basic},), b)
end


##################################################
# N
"""
    N(a)
    N(Val(:Type), b::Basic)

Convert a SymEngine numeric value into a Julian number

"""
N(a::Integer) = a
N(a::Rational) = a
N(a::Complex) = a

N(b::Basic) = N(get_symengine_class_val(b), b)

function N(::Val{:Integer}, b::Basic)
    a = _convert(BigInt, b)
    if (a.size > 1 || a.size < -1)
        return a
    elseif (a.size == 0)
        return 0
    else
        u = unsafe_load(a.d, 1)
        w = signed(u)
        if w > 0
            return w * a.size
        elseif a.size == 1
            return u
        else
            return a
        end
    end
end

# TODO: conditionally wrap rational_get_mpq from cwrapper.h
N(::Val{:Rational},   b::Basic) = Rational(N(numerator(b)), N(denominator(b)))
N(::Val{:RealDouble}, b::Basic) = _convert(Cdouble, b)
N(::Val{:RealMPFR},   b::Basic) = _convert(BigFloat, b)
N(::Val{:Complex},    b::Basic) = complex(N(real(b)), N(imag(b)))
N(::Val{:ComplexMPC}, b::Basic) = complex(N(real(b)), N(imag(b)))
N(::Val{:ComplexDouble}, b::Basic) = complex(N(real(b)), N(imag(b)))

N(::Val{:NaN},        b::Basic) = NaN
function N(::Val{:Infty}, b::Basic)
    if b == oo
        return Inf
    elseif b == zoo
        return Complex(Inf,Inf)
    elseif b == -oo
        return -Inf
    else
        throw(ArgumentError("Unknown infinity symbol"))
    end
end

function N(::Val{:Constant}, b::Basic)
    if b == PI
        return π
    elseif b == EulerGamma
        return γ
    elseif b == E
        return ℯ
    elseif b == Catalan
        return catalan
    elseif b == GoldenRatio
        return φ
    else
        throw(ArgumentError("Unknown constant"))
    end
end

function N(::Val{<:Any}, b::Basic)
    is_constant(b) ||
        throw(ArgumentError("Object can have no free symbols"))
    out = evalf(b)
    imag(out) == Basic(0.0) ? N(real(out)) : N(out)
end

unwrap_const(b) = is_constant(b) ? N(b) : b

## deprecate N(::BasicType)
N(b::BasicType{T}) where {T} = N(convert(Basic, b), T)

##  Conversions SymEngine -> Julia
## define convert(T, x) methods leveraging N() when needed
function convert(::Type{Float64}, x::Basic)
    is_a_RealDouble(x) && return _convert(Cdouble, x)
    convert(Float64, N(evalf(x, 53, true)))
end

function convert(::Type{BigFloat}, x::Basic)
    is_a_RealMPFR(x) && return _convert(BigFloat, x)
    convert(BigFloat, N(evalf(x, precision(BigFloat), true)))
end

function convert(::Type{Complex{Float64}}, x::Basic)
    z = is_a_ComplexDouble(x) ? x : evalf(x, 53, false)
    a,b = _real(z), _imag(z)
    u,v = _convert(Cdouble, a), _convert(Cdouble, b)
    return complex(u,v)
end

function convert(::Type{Complex{BigFloat}}, x::Basic)
    z =  is_a_ComplexMPC(x) ? x : evalf(x, precision(BigFloat), false)
    a,b = _real(z), _imag(z)
    u,v = _convert(BigFloat, a), _convert(BigFloat, b)
    return complex(u,v)
end

convert(::Type{Number}, x::Basic)            = x
convert(::Type{T}, x::Basic) where {T <: Real}      = convert(T, N(x))
convert(::Type{Complex{T}}, x::Basic) where {T <: Real}    = convert(Complex{T}, N(x))

# Constructors no longer fall back to `convert` methods
Base.Int64(x::Basic)   = convert(Int64, x)
Base.Int32(x::Basic)   = convert(Int32, x)
Base.Float32(x::Basic) = convert(Float32, x)
Base.Float64(x::Basic) = convert(Float64, x)
Base.BigInt(x::Basic)  = convert(BigInt, x)
Base.Real(x::Basic)    = convert(Real, x)


##  Rational --  p/q parts
function as_numer_denom!(a::Basic, b::Basic, x::Basic)
    ccall((:basic_as_numer_denom, libsymengine), Nothing, (Ref{Basic}, Ref{Basic}, Ref{Basic}), a, b, x)
    return a, b
end
function as_numer_denom(x::Basic)
    a, b = Basic(), Basic()
    as_numer_denom!(a,b,x)
end

as_numer_denom(x::BasicType) = as_numer_denom(Basic(x))
denominator(x::SymbolicType) = as_numer_denom(x)[2]
numerator(x::SymbolicType)   = as_numer_denom(x)[1]

## Complex
# b::Basic -> a::Basic
function _real(b::Basic)
    if is_a_RealDouble(b) || is_a_RealMPFR(b) || is_a_Integer(b) || is_a_Rational(b)
        return b
    end
    if !(is_a_Complex(b) || is_a_ComplexDouble(b) || is_a_ComplexMPC(b))
        throw(ArgumentError("Not a complex number"))
    end
    a = Basic()
    ccall((:complex_base_real_part, libsymengine), Nothing, (Ref{Basic}, Ref{Basic}), a, b)
    return a
end

function _imag(b::Basic)
    if !(is_a_Complex(b) || is_a_ComplexDouble(b) || is_a_ComplexMPC(b))
        throw(ArgumentError("Not a complex number"))
    end
    a = Basic()
    ccall((:complex_base_imaginary_part, libsymengine), Nothing, (Ref{Basic}, Ref{Basic}), a, b)
    return a
end

real(x::Basic) = Basic(real(SymEngine.BasicType(x)))
real(x::SymEngine.BasicType) = x

imag(x::Basic) = Basic(imag(SymEngine.BasicType(x)))
imag(x::BasicType{Val{:Integer}}) = Basic(0)
imag(x::BasicType{Val{:RealDouble}}) = Basic(0)
imag(x::BasicType{Val{:RealMPFR}}) = Basic(0)
imag(x::BasicType{Val{:Rational}}) = Basic(0)
imag(x::SymEngine.BasicType) = throw(InexactError())

# Because of the definitions above, `real(x) == x` for `x::Basic`
# such as `x = symbols("x")`. Thus, it is consistent to define the
conj(x::Basic) = Basic(conj(SymEngine.BasicType(x)))
# To allow future extension, we define the fallback on `BasicType``.
conj(x::BasicType) = 2 * real(x.x) - x.x


## For generic programming in Julia
float(x::Basic) = float(N(x))

# trunc, flooor, ceil, round, rem, mod, cld, fld,
isfinite(x::Basic) = x-x == 0
isnan(x::Basic) = ( x == NAN )
isinf(x::Basic) = !isnan(x) & !isfinite(x)
isless(x::Basic, y::Basic) = isless(N(x), N(y))

# is_a_functions
# could use metaprogramming here
is_a_Number(x::Basic) =
    Bool(convert(Int, ccall((:is_a_Number, libsymengine),
                            Cuint, (Ref{Basic},), x)))
is_a_Integer(x::Basic) =
    Bool(convert(Int, ccall((:is_a_Integer, libsymengine),
                            Cuint, (Ref{Basic},), x)))
is_a_Rational(x::Basic) =
    Bool(convert(Int, ccall((:is_a_Rational, libsymengine),
                            Cuint, (Ref{Basic},), x)))
is_a_RealDouble(x::Basic) =
    Bool(convert(Int, ccall((:is_a_RealDouble, libsymengine),
                            Cuint, (Ref{Basic},), x)))
is_a_RealMPFR(x::Basic) =
    Bool(convert(Int, ccall((:is_a_RealMPFR, libsymengine),
                            Cuint, (Ref{Basic},), x)))
is_a_Complex(x::Basic) =
    Bool(convert(Int, ccall((:is_a_Complex, libsymengine),
                            Cuint, (Ref{Basic},), x)))
is_a_ComplexDouble(x::Basic) =
    Bool(convert(Int, ccall((:is_a_ComplexDouble, libsymengine),
                            Cuint, (Ref{Basic},), x)))
is_a_ComplexMPC(x::Basic) =
    Bool(convert(Int, ccall((:is_a_ComplexMPC, libsymengine),
                            Cuint, (Ref{Basic},), x)))

Base.isinteger(x::Basic) = is_a_Integer(x)

function Base.isreal(x::Basic)
    is_a_Number(x) || return false
    is_a_Integer(x) || is_a_Rational(x) || is_a_RealDouble(x) || is_a_RealMPFR(x)
end

# may not allocate; seems more idiomatic than default x == zero(x)
function Base.iszero(x::Basic)
    is_a_Number(x) || return false
    x == zero(x)
end

function Base.isone(x::Basic)
    is_a_Number(x) || return false
    x == one(x)
end

## julia predicates we can mirror
function Base.iseven(x::Basic)
    is_constant(x) || throw(ArgumentError("Non constant argument"))
    iseven(N(x))
end

function Base.isodd(x::Basic)
    is_constant(x) || throw(ArgumentError("Non constant argument"))
    isodd(N(x))
end


## These should have support in symengine-wrapper, but currently don't
trunc(x::Basic, args...) = Basic(trunc(N(x), args...))
trunc(::Type{T},x::Basic, args...) where {T <: Integer} = convert(T, trunc(x,args...))

round(x::Basic; kwargs...) = Basic(round(N(x); kwargs...))
round(::Type{T},x::Basic; kwargs...) where {T <: Integer} = convert(T, round(x; kwargs...))

prec(x::Basic) = prec(BasicType(x))
prec(x::BasicType{Val{:RealMPFR}}) = ccall((:real_mpfr_get_prec, libsymengine), Clong, (Ref{Basic},), x)
prec(::BasicType) = throw(ArgumentError("Method not applicable"))

# eps
eps(x::Basic) = eps(BasicType(x))
eps(x::BasicType{T}) where {T} = eps(typeof(x))
eps(::Type{T}) where {T <: BasicType} = 0
eps(::Type{T}) where {T <: Basic} = 0
eps(::Type{BasicType{Val{:RealDouble}}}) = 2^-52
eps(::Type{BasicType{Val{:ComplexDouble}}}) = 2^-52
eps(x::BasicType{Val{:RealMPFR}}) = evalf(Basic(2), prec(x), true) ^ (-prec(x)+1)
eps(x::BasicType{Val{:ComplexMPFR}}) = eps(real(x))

## convert from BasicType
function convert(::Type{BigInt}, b::BasicType{Val{:Integer}})
    _convert(BigInt, Basic(b))
end

function convert(::Type{BigFloat}, b::BasicType{Val{:RealMPFR}})
    _convert(BigInt, Basic(b))
end

function convert(::Type{Cdouble}, b::BasicType{Val{:RealDouble}})
    _convert(Cdouble, Basic(b))
end

## real/imag for BasicType
function real(b::BasicComplexNumber)
    _real(Basic(b))
end

function imag(b::BasicComplexNumber)
    _imag(Basic(b))
end
## end deprecate

## We have different types:
##
## Basic: holds a ptr to a symengine object. Faster, so is default type
##
## BasicType{Val{:XXX}}: types that can be use to control dispatch
##
## SymbolicType: is a type union of the two
##
## Basic(x::BasicType) gives a basic object; BasicType(x::Basic) gives a BasicType object. (This name needs change)
##
## To control dispatch, one might have `N(b::Basic) = N(BasicType(b))` and then define `N` for types of interest


basic_free(b::Basic) = ccall((:basic_free_stack, libsymengine), Nothing, (Ref{Basic}, ), b)

function convert(::Type{Basic}, x::Clong)
    a = Basic()
    ccall((:integer_set_si, libsymengine), Nothing, (Ref{Basic}, Clong), a, x)
    return a
end

function convert(::Type{Basic}, x::Culong)
    a = Basic()
    ccall((:integer_set_ui, libsymengine), Nothing, (Ref{Basic}, Culong), a, x)
    return a
end

function convert(::Type{Basic}, x::BigInt)
    a = Basic()
    ccall((:integer_set_mpz, libsymengine), Nothing, (Ref{Basic}, Ref{BigInt}), a, x)
    return a
end

function convert(::Type{Basic}, s::String)
    a = Basic()
    b = ccall((:basic_parse, libsymengine), Cuint, (Ref{Basic}, Ptr{Int8}), a, s)
    throw_if_error(b, s)
    return a
end

function convert(::Type{Basic}, ex::Expr)
    expr = copy(ex)
    Basic(string(expr))
end

convert(::Type{Basic}, ex::Symbol) = Basic(string(ex))

function convert(::Type{Basic}, x::Cdouble)
    a = Basic()
    ccall((:real_double_set_d, libsymengine), Nothing, (Ref{Basic}, Cdouble), a, x)
    return a
end

function convert(::Type{Basic}, x::BigFloat)
    if (x.prec <= 53)
        return convert(Basic, Cdouble(x))
    elseif have_mpfr
        a = Basic()
        ccall((:real_mpfr_set, libsymengine), Nothing, (Ref{Basic}, Ref{BigFloat}), a, x)
        return a
    else
        warn("SymEngine is not compiled with MPFR support. Converting will lose precision.")
        return convert(Basic, Cdouble(x))
    end
end

if Clong == Int32
    convert(::Type{Basic}, x::Union{Int8, Int16}) = Basic(convert(Clong, x))
    convert(::Type{Basic}, x::Union{UInt8, UInt16}) = Basic(convert(Culong, x))
else
    convert(::Type{Basic}, x::Union{Int8, Int16, Int32}) = Basic(convert(Clong, x))
    convert(::Type{Basic}, x::Union{UInt8, UInt16, UInt32}) = Basic(convert(Culong, x))
end
convert(::Type{Basic}, x::Union{Float16, Float32}) = Basic(convert(Cdouble, x))
convert(::Type{Basic}, x::Integer) = Basic(BigInt(x))
convert(::Type{Basic}, x::Rational) = Basic(numerator(x)) / Basic(denominator(x))
convert(::Type{Basic}, x::Complex) = Basic(real(x)) + Basic(imag(x)) * IM

Basic(x::T) where {T} = convert(Basic, x)
Basic(x::Basic) = x

Base.promote_rule(::Type{Basic}, ::Type{S}) where {S<:Number} = Basic
Base.promote_rule(::Type{S}, ::Type{Basic}) where {S<:Number} = Basic
Base.promote_rule(::Type{S}, ::Type{Basic}) where {S<:AbstractIrrational} = Basic

## Class ID
get_type(s::Basic) = ccall((:basic_get_type, libsymengine), UInt, (Ref{Basic},), s)
function get_class_from_id(id::UInt)
    a = ccall((:basic_get_class_from_id, libsymengine), Ptr{UInt8}, (Int,), id)
    str = unsafe_string(a)
    ccall((:basic_str_free, libsymengine), Nothing, (Ptr{UInt8}, ), a)
    str
end

# use value of `get_type` to index into a vector storing symbols
function _get_symengine_classes()
    d = Vector{Symbol}()
    i = 0
    while true
      s = get_class_from_id(UInt(i))
      if s == ""
          break
    end
      push!(d, Symbol(s))
      i+=1
  end
    return d
end

const symengine_classes = _get_symengine_classes()
const symengine_classes_val = [Val(c) for c in SymEngine.symengine_classes]
const symengine_classes_val_type = [Val{c} for c in SymEngine.symengine_classes]

"""
    get_symengine_class(s)

Get SymEngine class of an object `s`.
(e.g. `1=>:Integer`, `1//2 =>:Rational`, `sin(x) => :Sin`, ...)
"""
get_symengine_class(s::Basic) = symengine_classes[get_type(s) + 1]
get_symengine_class_val(s::Basic) = symengine_classes_val[get_type(s) + 1]
get_symengine_class_val_type(s::Basic) = symengine_classes_val_type[get_type(s) + 1]


## Construct symbolic objects
## renamed, as `Symbol` conflicts with Base.Symbol
function _symbol(s::String)
    a = Basic()
    ccall((:symbol_set, libsymengine), Nothing, (Ref{Basic}, Ptr{Int8}), a, s)
    return a
end
_symbol(s::Symbol) = _symbol(string(s))

## use SymPy name here, but no assumptions
"""
    symbols(::Symbol)

Construct symbolic value.

### Examples

```julia
a = symbols(:a)
x = symbols("x")
x,y = symbols("x y")
x,y,z = symbols("x,y,z")
```

"""
symbols(s::Symbol) = _symbol(s)
function symbols(s::String)
    ## handle space or comma sparation
    s = replace(s, ","=> " ")
    by_space = split(s, r"\s+")
    Base.length(by_space) == 1 && return symbols(Symbol(s))
    tuple([_symbol(Symbol(o)) for o in by_space]...)
end

## Follow, somewhat, the python names: symbols to construct symbols, @vars

"""
    @vars x y[1:5] z()

Macro to define 1 or more variables or symbolic function

### Examples
```
@vars x y z
@vars x[1:4]
@vars u(), x
```

"""
macro vars(xs...)
    # If the user separates declaration with commas, the top-level expression is a tuple
    if length(xs) == 1 && isa(xs[1], Expr) && xs[1].head == :tuple
        _gensyms(xs[1].args...)
    elseif length(xs) > 0
        _gensyms(xs...)
    end
end

function _gensyms(xs...)
    asstokw(a) = Expr(:kw, esc(a), true)

    # Each declaration is parsed and generates a declaration using `symbols`
    symdefs = map(xs) do expr
        decl = parsedecl(expr)
        symname = sym(decl)
        symname, gendecl(decl)
    end
    syms, defs = collect(zip(symdefs...))

    # The macro returns a tuple of Symbols that were declared
    Expr(:block, defs..., :(tuple($(map(esc,syms)...))))
end



## We also have a wrapper type that can be used to control dispatch
## pros: wrapping adds overhead, so if possible best to use Basic
## cons: have to write methods meth(x::Basic, ...) = meth(BasicType(x),...)

## Parameterized type allowing for dispatch on Julia side by type of objecton SymEngine side
## Use as BasicType{Val{:Integer}}(...)
## To take advantage of this, define
## meth(x::Basic) = meth(BasicType(x))
## and then
## meth(x::BasicType{Val{:Integer}}) = ... or
## meth(x::BasicNumber) = ...
struct BasicType{T} <: Number
    x::Basic
end

convert(::Type{Basic}, x::Basic) = x

SymbolicType = Union{Basic, BasicType}
convert(::Type{Basic}, x::BasicType) = x.x
Basic(x::BasicType) = x.x

BasicType(val::Basic) =  BasicType{get_symengine_class_val_type(val)}(val)
convert(::Type{BasicType{T}}, val::Basic) where {T} =
    BasicType{get_symengine_class_val_type(val)}(val)
# Needed for julia v0.4.7
convert(::Type{T}, x::Basic) where {T<:BasicType} = BasicType(x)


## We have Basic and BasicType{...}. We go back and forth with:
## Basic(b::BasicType) and BasicType(b::Basic)

# for mathops
Base.promote_rule(::Type{T}, ::Type{S} ) where {T<:BasicType, S<:Number} = T
Base.promote_rule(::Type{S}, ::Type{T} ) where {T<:BasicType, S<:Number} = T

# to intersperse BasicType and Basic in math ops
Base.promote_rule(::Type{T}, ::Type{Basic} ) where {T<:BasicType} = T
Base.promote_rule( ::Type{Basic}, ::Type{T} ) where {T<:BasicType} = T
Base.promote_rule(::Type{S}, ::Type{T}) where {S<:AbstractIrrational, T<:BasicType} = T

## needed for mathops
convert(::Type{T}, val::Number) where {T<:BasicType} = T(Basic(val))
## Julia v0.6 errors with ambiguous error if this method is not defined.
convert(::Type{T}, val::T) where {T<:BasicType} = val


## some type unions possibly useful for dispatch
## Names here match those returned by get_symengine_class()
const real_number_types = [:Integer, :RealDouble, :Rational, :RealMPFR]
const complex_number_types = [:Complex, :ComplexDouble, :ComplexMPC]
const number_types = vcat(real_number_types, complex_number_types)
const BasicNumber = Union{[SymEngine.BasicType{Val{i}} for i in number_types]...}
const BasicRealNumber = Union{[SymEngine.BasicType{Val{i}} for i in real_number_types]...}
const BasicComplexNumber = Union{[SymEngine.BasicType{Val{i}} for i in complex_number_types]...}

const op_types = [:Mul, :Add, :Pow, :Symbol, :Const]
const BasicOp = Union{[SymEngine.BasicType{Val{i}} for i in op_types]...}

const trig_types = [:Sin, :Cos, :Tan, :Csc, :Sec, :Cot, :ASin, :ACos, :ATan, :ACsc, :ASec, :ACot]
const BasicTrigFunction =  Union{[SymEngine.BasicType{Val{i}} for i in trig_types]...}



###

"""
    is_constant(ex)

Is expression constant
"""
function is_constant(ex::Basic)
    is_a_Number(ex) && return true
    syms = CSetBasic()
    ccall((:basic_free_symbols, libsymengine), Nothing, (Ref{Basic}, Ptr{Cvoid}), ex, syms.ptr)
    Base.length(syms) == 0
end

"""
    is_symbol(x::)

Is expression a symbol
"""
function is_symbol(x::SymbolicType)
    res = ccall((:is_a_Symbol, libsymengine), Cuint, (Ref{Basic},), x)
    Bool(convert(Int,res))
end

"""
    has_symbol(ex, x)

Does expression `ex` contain the symbol `x`
"""
function has_symbol(ex::SymbolicType, x::SymbolicType)
    is_symbol(x) || throw(ArgumentError("Not a symbol"))
    res = ccall((:basic_has_symbol, libsymengine), Cuint, (Ref{Basic},Ref{Basic}),  ex, x)
    Bool(convert(Int, res))
end


"""
    free_symbols(ex)

Return free symbols in an expression `ex` as a `Set`
"""
function free_symbols(ex::Basic)
    syms = CSetBasic()
    free_symbols!(syms, ex)
    convert(Vector, syms)
end
function free_symbols!(syms::CSetBasic, ex::Basic)
    ccall((:basic_free_symbols, libsymengine), Nothing, (Ref{Basic}, Ptr{Cvoid}), ex, syms.ptr)
    syms
end

free_symbols(ex::BasicType) = free_symbols(Basic(ex))

_flat(A) = mapreduce(x->isa(x,Array) ? _flat(x) : x, vcat, A, init=Basic[])  # from rosetta code example

free_symbols(exs::Array{T}) where {T<:SymbolicType}  = unique(_flat([free_symbols(ex) for ex in exs]))
free_symbols(exs::Tuple) =  unique(_flat([free_symbols(ex) for ex in exs]))

"""
    function_symbols(ex)

Return function symbols in an expression `ex` as a `Set`
"""
function function_symbols(ex::Basic)
    syms = CSetBasic()
    function_symbols!(syms, ex)
    convert(Vector, syms)
end
function function_symbols!(syms::CSetBasic, ex::Basic)
    ccall((:basic_function_symbols, libsymengine), Nothing, (Ptr{Cvoid}, Ref{Basic}), syms.ptr, ex)
    syms
end

function_symbols(ex::BasicType) = function_symbols(Basic(ex))
function_symbols(exs::Array{T}) where {T<:SymbolicType} = unique(_flat([function_symbols(ex) for ex in exs]))
function_symbols(exs::Tuple) = unique(_flat([function_symbols(ex) for ex in exs]))

"""
    get_name(ex)

Return name of function symbol
"""
function get_name(ex::Basic)
    a = ccall((:function_symbol_get_name, libsymengine), Cstring, (Ref{Basic}, ), ex)
    string = unsafe_string(a)
    ccall((:basic_str_free, libsymengine), Nothing, (Cstring, ), a)
    return string
end

"""
    get_args(ex)

Return arguments of a function call as a vector of `Basic` objects
"""
function get_args(ex::Basic)
    args = CVecBasic()
    get_args!(args, ex)
    convert(Vector, args)
end

function get_args!(args::CVecBasic, ex::Basic)
    ccall((:basic_get_args, libsymengine), Nothing, (Ref{Basic}, Ptr{Cvoid}), ex, args.ptr)
end

## so that Dicts will work
basic_hash(ex::Basic) = ccall((:basic_hash, libsymengine), UInt, (Ref{Basic}, ), ex)
# similar definition as in Base for general objects
Base.hash(ex::Basic, h::UInt) = Base.hash_uint(3h - basic_hash(ex))
Base.hash(ex::BasicType, h::UInt) = hash(Basic(ex), h)


function Serialization.serialize(s::Serialization.AbstractSerializer, m::Basic)
	Serialization.serialize_type(s, typeof(m))

	size = Ref{UInt64}(0)
	serialized = ccall((:basic_dumps, libsymengine),
		Ptr{Int8}, (Ref{Basic}, Ptr{UInt64}), m, size)

	write(s.io, size[])
	unsafe_write(s.io, serialized, size[])
end

function Serialization.deserialize(s::Serialization.AbstractSerializer, ::Type{Basic})
    size = read(s.io, UInt64)
    serialized_data = read(s.io, size)

	a = Basic()
	res = ccall((:basic_loads, libsymengine),
		Cuint, (Ref{Basic}, Ptr{Int8}, UInt64), a, serialized_data, size)
	throw_if_error(res)
	return a
end

import Base: diff


## diff(ex, x)         f'
## what is the rest of the interface. This does:
## diff(ex, x, n)      f^(n)
## diff(ex, x, y, ...) f_{xy...}  # also diff(ex, (x,y))
## Support for diff(ex, x,n1, y,n2, ...),
## but can also do diff(ex, (x,y), (n1, n2))


function diff!(a::Basic, b1::SymbolicType, b2::Basic)
    is_symbol(b2) || throw(ArgumentError("Must differentiate with respect to a symbol"))
    ret = ccall((:basic_diff, libsymengine), Int, (Ref{Basic}, Ref{Basic}, Ref{Basic}), a, b1, b2)
    return a
end

function diff(b1::SymbolicType, b2::Basic)
    a = Basic()
    diff!(a, b1, b2)
    a
end

function diff(b1::SymbolicType, b2::SymbolicType, n::Integer)
    n < 0 && throw(DomainError("n must be non-negative integer"))
    n == 0 && return b1
    x = Basic(b2)
    out = Basic()
    diff!(out, b1, x)
    for _ in (n-1):-1:1
        diff!(out, out, x)
    end
    out
end

function diff(b1::SymbolicType, b2::SymbolicType, n::Integer, xs...)
    diff(diff(b1,b2,n), xs...)
end

function diff(b1::SymbolicType, b2::SymbolicType, b3::SymbolicType)
    if isinteger(b3)
        n = N(b3)::Int
        diff(b1, b2, n)
    else
        ex = diff(b1, b2)
        diff(ex, b3)
    end
end

function diff(b1::SymbolicType, b2::SymbolicType, b3::SymbolicType, bs...)
    diff(diff(b1,b2,b3), bs...)
end

function diff(b1::SymbolicType)
    xs = free_symbols(b1)
    n = length(xs)
    n == 0 && return zero(b1)
    n > 1 && throw(ArgumentError("More than one variable; one must be specified"))
    diff(b1, only(xs))
end

## deprecate
diff(b1::SymbolicType, b2::BasicType{Val{:Symbol}}) = diff(b1, Basic(b2))
diff(b1::SymbolicType, b2::BasicType) =
    throw(ArgumentError("Second argument must be of Symbol type"))

## mixed partials
diff(ex::SymbolicType, bs::Tuple) = reduce((ex, x) -> diff(ex, x), bs, init=ex)
diff(ex::SymbolicType, bs::Tuple, ns::Tuple) =
    reduce((ex, x) -> diff(ex, x[1],x[2]), zip(bs, ns), init=ex)

diff(b1::SymbolicType, x::Union{String,Symbol}) = diff(b1, Basic(x))

"""
    series(ex, x, x0=0, n=6)

Series expansion to order `n` about point `x0`
"""
function series(ex::SymbolicType, x::SymbolicType, x0=0, n::Union{Integer, Basic}=6)
    (!isa(N(n), Integer) || n < 0) && throw(DomainError("n must be non-negative integer"))

    fc = subs(ex, x, x0)
    n==0 && return fc

    fp = ex
    nfact = Basic(1)
    for k in 1:n
        fp = diff(fp, x)
        nfact = k * nfact
        fc = fc + subs(fp, x, x0) * (x-x0)^k / nfact
    end

    fc
end

using SymEngine
using Compat
using Test
using Serialization
import Base: MathConstants.γ, MathConstants.e, MathConstants.φ, MathConstants.catalan

VERSION >= v"1.9" && include("test-SymbolicUtils.jl")
include("test-dense-matrix.jl")

x = symbols("x")
y = symbols(:y)
@vars z

# Check Basic conversions
@test eltype([Basic(u) for u in [1, 1/2, 1//2, pi, e]]) == Basic

# make sure @vars defines in a local scope
let
    @vars w
end
@test_throws UndefVarError isdefined(w)
@test repr(Basic()) == "<Unitialized Basic value>"

# test @vars constructions
@vars a, b[0:4], c(), d=>"D"
@test length(b) == 5
@test isa(c, SymFunction)
@test repr(d) == "D"

a = x^2 + x/2 - x*y*5
b = diff(a, x)
@test b == 2*x + 1//2 - 5*y

c = x + Rational(1, 5)
c = expand(c * 5)
@test c == 5*x + 1

c = sum(convert(SymEngine.CVecBasic, [x, x, 1]))
@test c == 2*x + 1
@test x + x + 1 == 2*x + 1
@test x + 1 + 1 == x + 2
@test 1 + x + 1 == x + 2

c = prod(convert(SymEngine.CVecBasic, [x, x, 2]))
@test c == 2*x^2
@test x * x * 2 == 2*x^2
@test x * 2 * 3 == 6 * x
@test 2 * 3 * x == 6 * x
@test 2 * x * 3 == 6 * x
@test 3 * 2 * x == 6 * x

# https://github.com/symengine/SymEngine.jl/issues/259
@testset "Issue #259" begin
    let (a, b, c) = symbols("a b c")
        @test a * [b, c] == [a * b, a * c]
        @test a * 1//3 * [b, c] == [a * b / 3, a * c / 3]
        @test a * 1//3 * 3//4 * [b, c] == [a * b / 4, a * c / 4]
        @test a * 1//3 * 3//4 * 4//5 * [b, c] == [a * b / 5, a * c / 5]
    end
end

c = x ^ 5
@test diff(c, x) == 5 * x ^ 4

c = x ^ y
@test c != y^x

c = Basic(-5)
@test abs(c) == 5
@test abs(c) != 4

repr("text/plain", a) == (1/2)*x - 5*x*y + x^2
repr("text/plain", b) == 1/2 + 2*x - 5*y

@test 1 // x == 1 / x
@test x // 2 == (1//2) * x
@test x // y == x / y


## mathfuns
@test abs(Basic(-1)) == 1
@test sin(Basic(1)) == subs(sin(x), x, 1)
@test sin(PI) == 0
@test subs(sin(x), x, pi) == 0
@test sind(Basic(30)) == 1 // 2

## predicates
@vars x
u,v,w = x(2.1), x(1), x(0)
@test isreal(u)
@test !isinteger(u)
@test isinteger(v)
@test isone(v)
@test iszero(w)
@test iseven(u) == iseven(v)
@test iseven(w)
@test_throws ArgumentError iseven(x)
@test isodd(w) == isodd(u)
@test isodd(v)
@test_throws ArgumentError isodd(x)
@test (@allocated isreal(u)) == 0
@test (@allocated isinteger(v)) == 0
@test (@allocated isone(x)) == 0
@test (@allocated iszero(x)) == 0
@test (@allocated isone(v)) > 0 # checking v==zero(v) value allocates
@test (@allocated iszero(w)) > 0
@test (@allocated iseven(v)) > 0
@test (@allocated isodd(v)) > 0

## calculus
x,y = symbols("x y")
@test diff(log(x)) == 1/x
@test diff(log(x),x) == 1/x
@test_throws ArgumentError diff(log(x), x^2)

n = Basic(2)
ex = sin(x*y)
@test_throws ArgumentError diff(ex)
@test diff(ex, x) == y * cos(x*y)
@test diff(ex, x, 2) == diff(diff(ex,x), x)
@test diff(ex, x, n) == diff(diff(ex,x), x)
@test diff(ex, x, y) == diff(diff(ex,x), y)
@test diff(ex, x, y, x) == diff(diff(diff(ex,x), y), x)
@test diff(ex, x, 2, y, 3) == diff(ex, x,x,y,y,y)
@test diff(ex, x, n, y, 3) == diff(ex, x,x,y,y,y)
@test diff(ex, x, 2, y, x) == diff(ex, x,x,x,y)

@test series(sin(x), x, 0, 2) == x
@test series(sin(x), x, 0, 3) == x - x^3/6

## ntheory
@test mod(Basic(10), Basic(4)) == 2
for j in [-3, 3], p in [-5,5]
    @test mod(Basic(j), Basic(p)) == mod(j, p)
end
@test mod(Basic(10), 4) == 2               # mod(::Basic, ::Number)
@test_throws MethodError mod(10, Basic(4)) # no mod(::Number, ::Basic)
@test gcd(Basic(10), Basic(4)) == 2
@test lcm(Basic(10), Basic(4)) == 20
@test binomial(Basic(5), 2) == 10


## type information
a = Basic(1)
b = Basic(1//2)
c = Basic(0.125)
@test isa(SymEngine.BasicType(a+a), SymEngine.BasicType{Val{:Integer}})
@test isa(SymEngine.BasicType(a+b), SymEngine.BasicType{Val{:Rational}})
@test isa(SymEngine.BasicType(a+c), SymEngine.BasicType{Val{:RealDouble}})
@test isa(SymEngine.BasicType(b+c), SymEngine.BasicType{Val{:RealDouble}})
@test isa(SymEngine.BasicType(c+c), SymEngine.BasicType{Val{:RealDouble}})

## can we do math with items of BasicType?
a1 = SymEngine.BasicType(a)
tot = a1
for i in 1:100
    global tot
    tot = tot + a1
end
@test tot == 101
sin(a1)

# samples of different types:
# (Int, Rational{Int}, Complex{Int}, Float64, Complex{Float64})
samples = (1, 1//2, (1 + 2im), 1.0, (1.0 + 0im))
## subs - check all different syntaxes and types
ex = x^2 + y^2
for val in samples
    @test subs(ex, x, val) == val^2 + y^2
    @test subs(ex, (x, val)) == val^2 + y^2
    @test subs(ex, x => val) == val^2 + y^2
    @test subs(ex, SymEngine.CMapBasicBasic(Dict(x=>val))) == val^2 + y^2
    @test subs(ex, Dict(x=>val)) == val^2 + y^2
    @test subs(ex) == ex
end
# This probably results in a number of redundant tests (operator order).
for val1 in samples, val2 in samples
    @test subs(ex, (x, val1), (y, val2)) == val1^2 + val2^2
    @test subs(ex, x => val1, y => val2) == val1^2 + val2^2
end

## lambidfy
@test abs(lambdify(sin(Basic(1))) - sin(1)) <= 1e-14
fn = lambdify(exp(PI/2*x))
@test abs(fn(1) - exp(pi/2)) <= 1e-14
for val in samples
    ex2 = sin(x + val)
    fn2 = lambdify(ex2)
    @test abs(fn2(val) - sin(2*val)) <= 1e-14
end
@test lambdify(x^2)(3) == 9

A = [x 2; x 1]
@test lambdify(A, [x])(0) == [0 2; 0 1]
@test lambdify(A)(0) == [0 2; 0 1]
A = [x 2]
@test lambdify(A, [x])(1) == [1 2]
@test lambdify(A)(1) == [1 2]
@test isa(convert.(Expr, [0 x x+1]), Array{Expr})
@test all(x -> isa(x, Union{Number, Symbol, Expr}), SymEngine._convert.(Expr, [0 x x+1]))

## N, convert, _convert
for val in samples
    @test N(Basic(val)) == val
end

for val in [π, γ, e, φ, catalan]
    @test N(Basic(val)) == val
end

for a in Basic.((1, big(1)))
    @test SymEngine.isinteger(a)
    @test N(a) isa Int
    @test (@allocated convert(Int, a)) > 0
    @test (@allocated SymEngine._convert(Int, a)) == 0
end

for a in Basic.((big(10)^100,))
    @test SymEngine.isinteger(a)
    @test N(a) isa BigInt
    @test (@allocated convert(BigInt, a)) > 0
    @test (@allocated SymEngine._convert(BigInt, a)) > 0

    a′ = Basic(big(10)^10)
    _b = BigInt()
    @test (@allocated SymEngine._convert_bigint!(_b, a′)) == 0

end



for a in Basic.((1.0, 1.23, Inf))
    @test N(a) isa Float64
    @test float(a) == N(a)
    @test (@allocated convert(Float64, a)) >= 0
    @test (@allocated SymEngine._convert(Float64, a)) == 0
end

for a in Basic.((big(1.2)^100,))
    @test N(a) isa BigFloat
    @test (@allocated convert(BigFloat, a)) > 0
    @test (@allocated SymEngine._convert(BigFloat, a)) > 0
    _b = BigFloat()
    @test (@allocated SymEngine._convert_bigfloat!(_b, a)) == 0
end

for a in Basic.((1//2,))
    @test SymEngine.is_a_Rational(a)
    @test N(a) isa Rational
    @test (@allocated convert(Rational{Int}, a)) > 0
end

for (a,b) in (PI=>π, E=>ℯ,
              GoldenRatio => Base.MathConstants.golden,
              Catalan => Base.MathConstants.catalan,
              oo=>Inf, zoo => complex(Inf, Inf),
              )
    @test N(a) == b
end

@test isnan(N(NAN))

@test !isnan(x)
@test isnan(Basic(0)/0)

## generic linear algebra
x = symbols("x")
A = [x 2; x 1]
#@test det(A) == -x
#@test det(inv(A)) == - 1/x
#(A \ [1,2])[1] == 3/x

## check that unique work (hash)
x,y,z = symbols("x y z")
@test length(SymEngine.free_symbols([x*y, y,z])) == 3

# is/has/free symbol(s)
@vars x y z
@test SymEngine.is_symbol(x)
#@test (@allocated SymEngine.is_symbol(x)) == 0
@test !SymEngine.is_symbol(x(2))
@test !SymEngine.is_symbol(x^2)
@test SymEngine.has_symbol(x^2, x)
@test SymEngine.has_symbol(x, x)
@test @allocated(SymEngine.has_symbol(x, x)) == 0
@test SymEngine.has_symbol(sin(sin(sin(x))), x)
@test !SymEngine.has_symbol(x^2, y)
@test Set(free_symbols(x*y)) == Set([x,y])
@test Set(free_symbols(x*y^z)) != Set([x,y])

# call without specifying variables
@vars x y
z = x(2)
@test x(2) == 2
@test (x*y^2)(1,2) == subs(x*y^2, x=>1, y=>2) == (x*y^2)(x=>1, y=>2)
@test z() == 2
@test z(1) == 2

## check that callable symengine expressions can be used as functions for duck-typed functions
@vars x
function simple_newton(f, fp, x0)
    x = float(x0)
    while abs(f(x)) >= 1e-14
        x = x - f(x)/fp(x)
    end
    x
end
@test abs(simple_newton(sin(x), diff(sin(x), x), 3) - pi) <= 1e-14

## Check conversions SymEngine -> Julia
z,flt, rat, ima, cplx = btypes = [Basic(1), Basic(1.23), Basic(3//5), Basic(2im), Basic(1 + 2im)]

@test Int(z) == 1
@test BigInt(z) == 1
@test Float64(flt) ≈ 1.23
@test Real(flt) ≈ 1.23
@test convert(Rational{Int}, rat) == 3//5
@test convert(Complex{Int}, ima) == 2im
@test convert(Complex{Int}, cplx) == 1 + 2im
@test isinf(convert(Float64, oo))
@test isnan(convert(Float64, NAN))

@test_throws InexactError convert(Int, flt)
@test_throws InexactError convert(Int, rat)

x = symbols("x")
Number[1 2 3 x]
@test_throws ArgumentError Int[1 2 3 x]

t = BigFloat(1.23)
@test !SymEngine.have_component("mpfr") || t == convert(BigFloat, convert(Basic, t))

@test typeof(N(Basic(-1))) != BigInt

# Check that libversion works. VersionNumber should always be >= 0.2.0
# since 0.2.0 is the first public release
@test SymEngine.libversion >= VersionNumber("0.2.0")

# Check that constructing Basic from Expr works
@vars x y
@test Basic(:(-2*x)) == -2*x
@test Basic(:(-3*x*y)) == -3*x*y
@test Basic(:((x-y)*-3)) == (x-y)*(-3)
@test Basic(:(-y)) == -y
@test Basic(:(-2*(x-2*y))) == -2*(x-2*y)

# Check that constructing Basic from Irrational works
for a ∈ (:pi, :ℯ, :e, :φ, :γ,
         MathConstants.eulergamma,
         MathConstants.π,
         MathConstants.catalan,
         MathConstants.pi,
         MathConstants.φ,
         MathConstants.ℯ,
         MathConstants.e,
         MathConstants.golden,
         MathConstants.γ)
    @test Basic(a) isa Basic
end

@test Basic(0)/0 == NAN
@test subs(1/x, x, 0) == Basic(1)/0

d = Dict(x=>y, y=>x)
@test subs(x + 2*y, d) == y + 2*x

@test sin(x+PI/4) != sin(x)
@test sin(PI/2-x) == cos(x)

f = SymFunction("f")
@test nameof(f) == :f
@test_throws MethodError nameof(f(x))
@test string(f(x, y)) == "f(x, y)"
@test string(f([x, y])) == "f(x, y)"
@test string(f(2*x)) == "f(2*x)"

@funs g, h
@test string(g(x, y)) == "g(x, y)"
@test string(h(x, y)) == "h(x, y)"

# Function symbols
@funs f, g, h, s
@vars n, m
expr = Basic("f(n) + f(n+1) + g(m)^2 - 3*h(n)*s(n)^3")
@test function_symbols(expr) == [h(n), f(n), s(n), g(m), f(n+1)]
@test get_name(f(n+1)) == "f"
@test get_args(f(n+1)) == [n+1]
@test get_args(f(n, m^2)) == [n, m^2]

# Coefficients
@vars x y
expr = x^3 + 3*x^2*y + 3*x*y^2 + y^3 + 1
@test coeff(expr, x, Basic(3)) == 1
@test coeff(expr, x, Basic(2)) == 3*y
@test coeff(expr, x, Basic(1)) == 3*y^2
@test coeff(expr, x, Basic(0)) == y^3 + 1

# Check that infinities are handled correctly
@test_throws DomainError exp(zoo)
@test_throws DomainError sin(zoo)
@test_throws DomainError sin(oo)
@test_throws DomainError subs(sin(log(y - y/x)), x => 1)
@test_throws DomainError exp(zoo+x)/exp(x)

# Some basic checks for complex numbers
@testset "Complex numbers" begin
    for T in (Int, Float64, BigFloat)
        j = one(T) * IM
        @test j == imag(j) * IM
        @test conj(j) == -j
    end
end

@test round(Basic(3.14)) == 3.0
@test round(Basic(3.14); digits=1) == 3.1

function is_serialization_correct(expr :: Basic)
	iobuf = IOBuffer()
	serialize(iobuf, expr)
	seek(iobuf, 0)
	deserialized = deserialize(iobuf)
	close(iobuf)
	return expr == deserialized
end

@vars x y
@testset "Serialization and deserialization" begin
	@test is_serialization_correct(Basic(1.0))
	@test is_serialization_correct(Basic(pi))
	@test is_serialization_correct(Basic(x + y))
	@test is_serialization_correct(Basic(sin(cos(pi*x + y)) + y^2))

	# Complex type test
	iobuf = IOBuffer()
	data = [x+y, x+y]
	serialize(iobuf, data)
	seek(iobuf, 0)
	deserialized = deserialize(iobuf)
	close(iobuf)
	@test deserialized == data
end

VERSION >= v"1.9.0" && include("test-allocations.jl")

# types from SymEngine to Julia

## Basic
## Hold a reference to a SymEngine object
mutable struct Basic  <: Number
    ptr::Ptr{Cvoid}
    function Basic()
        z = new(C_NULL)
        ccall((:basic_new_stack, libsymengine), Nothing, (Ref{Basic}, ), z)
        finalizer(basic_free, z)
        return z
    end
    function Basic(v::Ptr{Cvoid})
        z = new(v)
        return z
    end
end

## CSetBasic
mutable struct CSetBasic
    ptr::Ptr{Cvoid}
end

function CSetBasic()
    z = CSetBasic(ccall((:setbasic_new, libsymengine), Ptr{Cvoid}, ()))
    finalizer(CSetBasic_free, z)
    z
end

function CSetBasic_free(x::CSetBasic)
    if x.ptr != C_NULL
        ccall((:setbasic_free, libsymengine), Nothing, (Ptr{Cvoid},), x.ptr)
        x.ptr = C_NULL
    end
end

function Base.length(s::CSetBasic)
    ccall((:setbasic_size, libsymengine), UInt, (Ptr{Cvoid},), s.ptr)
end

function Base.getindex(s::CSetBasic, n::UInt)
    result = Basic()
    ccall((:setbasic_get, libsymengine), Nothing, (Ptr{Cvoid}, UInt, Ref{Basic}), s.ptr, n, result)
    result
end

function Base.convert(::Type{Vector}, x::CSetBasic)
    n = Base.length(x)
    [x[i-1] for i in 1:n]
end
Base.convert(::Type{Set}, x::CSetBasic) = Set(convert(Vector, x))

## VecBasic Need this for get_args...

mutable struct CVecBasic
    ptr::Ptr{Cvoid}
end

function CVecBasic()
    z = CVecBasic(ccall((:vecbasic_new, libsymengine), Ptr{Cvoid}, ()))
    finalizer(CVecBasic_free, z)
    z
end

function CVecBasic_free(x::CVecBasic)
    if x.ptr != C_NULL
        ccall((:vecbasic_free, libsymengine), Nothing, (Ptr{Cvoid},), x.ptr)
        x.ptr = C_NULL
    end
end

function Base.length(s::CVecBasic)
    ccall((:vecbasic_size, libsymengine), UInt, (Ptr{Cvoid},), s.ptr)
end

function Base.getindex(s::CVecBasic, n)
    result = Basic()
    ccall((:vecbasic_get, libsymengine), Nothing, (Ptr{Cvoid}, UInt, Ref{Basic}), s.ptr, UInt(n), result)
    result
end

function Base.convert(::Type{Vector}, x::CVecBasic)
    n = Base.length(x)
    [x[i-1] for i in 1:n]
end

start(s::CVecBasic) = 0
done(s::CVecBasic, i) = (i == Base.length(s))
next(s::CVecBasic, i) = s[i], i+1
function Base.iterate(s::CVecBasic, i=start(s))
    done(s, i) && return nothing
    next(s, i)
end

## CMapBasicBasic
mutable struct CMapBasicBasic
    ptr::Ptr{Cvoid}
end

function CMapBasicBasic()
    z = CMapBasicBasic(ccall((:mapbasicbasic_new, libsymengine), Ptr{Cvoid}, ()))
    finalizer(CMapBasicBasic_free, z)
    z
end

function CMapBasicBasic(dict::AbstractDict)
    c = CMapBasicBasic()
    for (key, value) in dict
        c[Basic(key)] = Basic(value)
    end
    return c
end

function CMapBasicBasic_free(x::CMapBasicBasic)
    if x.ptr != C_NULL
        ccall((:mapbasicbasic_free, libsymengine), Nothing, (Ptr{Cvoid},), x.ptr)
        x.ptr = C_NULL
    end
end

function Base.length(s::CMapBasicBasic)
    ccall((:mapbasicbasic_size, libsymengine), UInt, (Ptr{Cvoid},), s.ptr)
end

function Base.getindex(s::CMapBasicBasic, k::Basic)
    result = Basic()
    ret = ccall((:mapbasicbasic_get, libsymengine), Cint, (Ptr{Cvoid}, Ref{Basic}, Ref{Basic}), s.ptr, k, result)
    if ret == 0
        throw(KeyError("Key not found"))
    end
    result
end

function Base.setindex!(s::CMapBasicBasic, v::Basic, k::Basic)
    ccall((:mapbasicbasic_insert, libsymengine), Nothing, (Ptr{Cvoid}, Ref{Basic}, Ref{Basic}), s.ptr, k, v)
end

Base.convert(::Type{CMapBasicBasic}, x::AbstractDict) = CMapBasicBasic(x)

## Dense matrix

mutable struct CDenseMatrix <: DenseArray{Basic, 2}
    ptr::Ptr{Cvoid}
end

Base.promote_rule(::Type{CDenseMatrix}, ::Type{Matrix{T}} ) where {T <: Basic} = CDenseMatrix

function CDenseMatrix_free(x::CDenseMatrix)
    if x.ptr != C_NULL
        ccall((:dense_matrix_free, libsymengine), Nothing, (Ptr{Cvoid},), x.ptr)
        x.ptr = C_NULL
    end
end

function CDenseMatrix()
    z = CDenseMatrix(ccall((:dense_matrix_new, libsymengine), Ptr{Cvoid}, ()))
    finalizer(CDenseMatrix_free, z)
    z
end

function CDenseMatrix(m::Int, n::Int)
    z = CDenseMatrix(ccall((:dense_matrix_new_rows_cols, libsymengine), Ptr{Cvoid}, (Int, Int), m, n))
    finalizer(CDenseMatrix_free, z)
    z
end


function CDenseMatrix(x::Array{T, 2}) where T
    r,c = size(x)
    M = CDenseMatrix(r, c)
    for j in 1:c
        for i in 1:r ## fill column by column
            M[i,j] = x[i,j]
        end
    end
    M
end


function Base.convert(::Type{Matrix}, x::CDenseMatrix)
    m,n = Base.size(x)
    [x[i,j] for i in 1:m, j in 1:n]
end

Base.convert(::Type{CDenseMatrix}, x::Array{T, 2}) where {T} = CDenseMatrix(x)
Base.convert(::Type{CDenseMatrix}, x::Array{T, 1}) where {T} = convert(CDenseMatrix, reshape(x, length(x), 1))


function toString(b::CDenseMatrix)
    a = ccall((:dense_matrix_str, libsymengine), Cstring, (Ptr{Cvoid}, ), b.ptr)
    string = unsafe_string(a)
    ccall((:basic_str_free, libsymengine), Nothing, (Cstring, ), a)
    string = replace(string, "**", "^") # de pythonify
    return string
end

function Base.show(io::IO, m::CDenseMatrix)
    r, c = size(m)
    println(io, "CDenseMatrix: $r x $c")
    println(io, toString(m))
end

import Base: +, -, ^, /, //, \, *, ==, sum, prod

## equality
function ==(b1::SymbolicType, b2::SymbolicType)
    b1,b2 = map(Basic, (b1, b2))
    ccall((:basic_eq, libsymengine), Int, (Ref{Basic}, Ref{Basic}), b1, b2) == 1
end


## main ops
for (op, libnm) in ((:+, :add), (:-, :sub), (:*, :mul), (:/, :div), (:^, :pow))
    tup = (Base.Symbol("basic_$libnm"), libsymengine)
    opbang = Symbol(libnm,:!)
    @eval begin
        function ($opbang)(a::Basic, b1::Basic, b2::Basic)
            err_code = ccall($tup, Cuint, (Ref{Basic}, Ref{Basic}, Ref{Basic}), a, b1, b2)
            throw_if_error(err_code, $(string(libnm)))
            return a
        end
        function ($op)(b1::Basic, b2::Basic)
            a = Basic()
            ($opbang)(a, b1, b2)
            return a
        end
        ($op)(b1::BasicType, b2::BasicType) = ($op)(Basic(b1), Basic(b2))
    end
end

^(a::T, b::S) where {T<:SymbolicType, S <: Integer} = Basic(a)^Basic(b)
^(a::T, b::S) where {T<:SymbolicType, S <: Rational} = Basic(a)^Basic(b)
+(b::SymbolicType) = b
-(b::SymbolicType) = 0 - b
\(b1::SymbolicType, b2::SymbolicType) = b2 / b1

# In contrast to other standard operations such as `+`, `*`, `-`, and `/`,
# Julia doesn't implement a general fallback of `//` for `Number`s promoting
# the input arguments. Thus, we implement this here explicitly.
Base.:(//)(b1::SymbolicType, b2::SymbolicType) = b1 / b2
Base.:(//)(b1::SymbolicType, b2::Number) = //(promote(b1, b2)...)
Base.:(//)(b1::Number, b2::SymbolicType) = //(promote(b1, b2)...)


function sum!(a::Basic, v::CVecBasic)
    err_code = ccall((:basic_add_vec, libsymengine), Cuint, (Ref{Basic}, Ptr{Cvoid}), a, v.ptr)
    throw_if_error(err_code, "add_vec")
    return a
end
function sum(v::CVecBasic)
    a = Basic()
    sum!(a, v)
end

+(b1::Basic, b2::Basic, b3::Basic, bs...) = sum(convert(CVecBasic, [b1, b2, b3, bs...]))
+(b1::Basic, b2::Basic, b3, bs...) = +(Basic(b1), Basic(b2), Basic(b3), bs...)
+(b1, b2::Basic, b3::Basic, bs...) = +(Basic(b1), Basic(b2), Basic(b3), bs...)
+(b1::Basic, b2, b3::Basic, bs...) = +(Basic(b1), Basic(b2), Basic(b3), bs...)

+(b1::Basic, b2, b3, bs...) = +(Basic(b1), Basic(b2), Basic(b3), bs...)
+(b1, b2::Basic, b3, bs...) = +(Basic(b1), Basic(b2), Basic(b3), bs...)
+(b1, b2, b3::Basic, bs...) = +(Basic(b1), Basic(b2), Basic(b3), bs...)


function prod!(a::Basic, v::CVecBasic)
    err_code = ccall((:basic_mul_vec, libsymengine), Cuint, (Ref{Basic}, Ptr{Cvoid}), a, v.ptr)
    throw_if_error(err_code, "mul_vec")
    return a
end
function prod(v::CVecBasic)
    a = Basic()
    prod!(a, v)
end

*(b1::Basic, b2::Basic, b3::Basic, bs::Vararg{Number, N}) where {N} = prod(convert(CVecBasic, [b1, b2, b3, bs...]))
*(b1::Basic, b2::Basic, b3::Number, bs::Vararg{Number, N}) where {N} = *(Basic(b1), Basic(b2), Basic(b3), bs...)
*(b1::Number, b2::Basic, b3::Basic, bs::Vararg{Number, N}) where {N} = *(Basic(b1), Basic(b2), Basic(b3), bs...)
*(b1::Basic, b2::Number, b3::Basic, bs::Vararg{Number, N}) where {N} = *(Basic(b1), Basic(b2), Basic(b3), bs...)

*(b1::Basic, b2::Number, b3::Number, bs::Vararg{Number, N}) where {N} = *(Basic(b1), Basic(b2), Basic(b3), bs...)
*(b1::Number, b2::Basic, b3::Number, bs::Vararg{Number, N}) where {N} = *(Basic(b1), Basic(b2), Basic(b3), bs...)
*(b1::Number, b2::Number, b3::Basic, bs::Vararg{Number, N}) where {N} = *(Basic(b1), Basic(b2), Basic(b3), bs...)


## ## constants
Base.zero(x::Basic) = Basic(0)
Base.zero(::Type{T}) where {T<:Basic} = Basic(0)
Base.one(x::Basic) = Basic(1)
Base.one(::Type{T}) where {T<:Basic} = Basic(1)

Base.zero(x::BasicType) = BasicType(Basic(0))
Base.zero(::Type{T}) where {T<:BasicType} = BasicType(Basic(0))
Base.one(x::BasicType) = BasicType(Basic(1))
Base.one(::Type{T}) where {T<:BasicType} = BasicType(Basic(1))


## Math constants
## no oo!

for op in [:IM, :PI, :E, :EulerGamma, :Catalan, :GoldenRatio, :oo, :zoo, :NAN]
    @eval begin
        const $op = Basic(C_NULL)
    end
    eval(Expr(:export, op))
end

macro init_constant(op, libnm)
    tup = (Base.Symbol("basic_const_$libnm"), libsymengine)
    alloc_tup = (:basic_new_stack, libsymengine)
    :(
        begin
            ccall($alloc_tup, Nothing, (Ref{Basic}, ), $op)
            ccall($tup, Nothing, (Ref{Basic}, ), $op)
            finalizer(basic_free, $op)
        end
    )
end

function init_constants()
    @init_constant IM I
    @init_constant PI pi
    @init_constant E E
    @init_constant EulerGamma EulerGamma
    @init_constant Catalan Catalan
    @init_constant GoldenRatio GoldenRatio
    @init_constant oo infinity
    @init_constant zoo complex_infinity
    @init_constant NAN nan
end

## ## Conversions
Base.convert(::Type{Basic}, x::Irrational{:π}) = PI
Base.convert(::Type{Basic}, x::Irrational{:e}) = E
Base.convert(::Type{Basic}, x::Irrational{:ℯ}) = E
Base.convert(::Type{Basic}, x::Irrational{:γ}) = EulerGamma
Base.convert(::Type{Basic}, x::Irrational{:catalan}) = Catalan
Base.convert(::Type{Basic}, x::Irrational{:φ}) = (1 + Basic(5)^Basic(1//2))/2
Base.convert(::Type{BasicType}, x::Irrational) = BasicType(convert(Basic, x))

## Logical operators
Base.:<(x::SymbolicType, y::SymbolicType) = N(x) < N(y)
Base.:<(x::SymbolicType, y) = <(promote(x,y)...)
Base.:<(x, y::SymbolicType) = <(promote(x,y)...)

## Other Basic Operations
Base.copysign(x::SymEngine.Basic,y::SymEngine.BasicType) = sign(y)*abs(x)

module SymEngineSymbolicUtilsExt

using SymEngine
using SymbolicUtils

# Needed for some simplification routines
# a total order <ₑ
import SymbolicUtils: <ₑ, isterm, isadd, ismul, issym, get_degrees, monomial_lt, _arglen

#Base.nameof(x::SymEngine.SymbolicType) = Symbol(x)
#
#function is_number(a::SymEngine.Basic)
#    cls = SymEngine.get_symengine_class(a)
#    any(==(cls), SymEngine.number_types) && return true
#    false
#end


function SymbolicUtils.:<ₑ(a::SymEngine.Basic, b::SymEngine.Basic)
    if !SymbolicUtils.iscall(a) || !SymbolicUtils.iscall(a)
        if !SymbolicUtils.iscall(a) && !SymbolicUtils.iscall(b)
            return <ₑ(Symbol(a), Symbol(b))
        elseif SymbolicUtils.iscall(a) && !SymbolicUtils.iscall(b)
            return false
        elseif !SymbolicUtils.iscall(a) && SymbolicUtils.iscall(b)
            return true
        end
    end

    da, db = get_degrees(a), get_degrees(b)
    fw = monomial_lt(da, db)
    bw = monomial_lt(db, da)
    if fw === bw && !isequal(a, b)
        if _arglen(a) == _arglen(b)
            return (operation(a), arguments(a)...,) <ₑ (operation(b), arguments(b)...,)
        else
            return _arglen(a) < _arglen(b)
        end
    else
        return fw
    end
end

Base.isless(x::Number, y::SymEngine.Basic) = isless(promote(x,y)...)
Base.isless(x::SymEngine.Basic,y::Number) = isless(promote(x,y)...)

end

## Dense matrix interface

dense_matrix_rows(s::CDenseMatrix) = ccall((:dense_matrix_rows, libsymengine), Int, (Ptr{Cvoid}, ), s.ptr)
dense_matrix_cols(s::CDenseMatrix) = ccall((:dense_matrix_cols, libsymengine), Int, (Ptr{Cvoid}, ), s.ptr)
function dense_matrix_rows_cols(mat::CDenseMatrix, r::UInt, c::UInt)
    ccall((:dense_matrix_rows_cols, libsymengine), Int, (Ptr{Cvoid}, UInt, UInt), s.ptr, r, c)
end


function dense_matrix_get_basic(s::CDenseMatrix, r::Int, c::Int)
    result = Basic()
    ccall((:dense_matrix_get_basic, libsymengine), Nothing, (Ref{Basic}, Ptr{Cvoid}, UInt, UInt), result, s.ptr, UInt(r), UInt(c))
    result
end


function dense_matrix_set_basic(s::CDenseMatrix, val, r::Int, c::Int)
    value = Basic(val)
    ccall((:dense_matrix_set_basic, libsymengine), Nothing, (Ptr{Cvoid}, UInt, UInt, Ref{Basic}), s.ptr, UInt(r), UInt(c), value)
    value
end



## Basic operations det, inv, transpose
function dense_matrix_det(s::CDenseMatrix)
    result = Basic()
    ccall((:dense_matrix_det, libsymengine), Nothing, (Ref{Basic}, Ptr{Cvoid}), result, s.ptr)
    result
end
function dense_matrix_inv(s::CDenseMatrix)
    result = CDenseMatrix()
    ccall((:dense_matrix_inv, libsymengine), Nothing, (Ptr{Cvoid}, Ptr{Cvoid}), result.ptr, s.ptr)
    result
end


function dense_matrix_transpose(s::CDenseMatrix)
    result = CDenseMatrix()
    ccall((:dense_matrix_transpose, libsymengine), Nothing, (Ptr{Cvoid}, Ptr{Cvoid}), result.ptr, s.ptr)
    result
end

function dense_matrix_submatrix(mat::CDenseMatrix, r1::Int, c1::Int, r2::Int, c2::Int, r::Int, c::Int)
    s = CDenseMatrix()
    ccall((:dense_matrix_inv, libsymengine), Nothing, (Ptr{Cvoid}, Ptr{Cvoid}, UInt, UInt, UInt, UInt, UInt, UInt),
          s.ptr, mat.ptr, UInt(r1), UInt(c1), UInt(r2), UInt(c2), UInt(r), UInt(c))
    s
end


## some matrix arithmetic methods
## These are unncecessary, as +,-,*,^ are inhertied by the AbstractArray Interface. Those return Array{Basic,2}. These
## return CDenseMatrix objects.
function dense_matrix_add_matrix(a::CDenseMatrix, b::CDenseMatrix)
    result = CDenseMatrix()
    ccall((:dense_matrix_add_matrix, libsymengine), Nothing, (Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}), result.ptr, a.ptr, b.ptr)
    result
end


function dense_matrix_mul_matrix(a::CDenseMatrix, b::CDenseMatrix)
    result = CDenseMatrix()
    ccall((:dense_matrix_mul_matrix, libsymengine), Nothing, (Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}), result.ptr, a.ptr, b.ptr)
    result
end

function dense_matrix_add_scalar(a::CDenseMatrix, b::Basic)
    result = CDenseMatrix()
    ccall((:dense_matrix_add_scalar, libsymengine), Nothing, (Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}), result.ptr, a.ptr, b.ptr)
    result
end


function dense_matrix_mul_scalar(a::CDenseMatrix, b::Basic)
    result = CDenseMatrix()
    ccall((:dense_matrix_mul_scalar, libsymengine), Nothing, (Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}), result.ptr, a.ptr, b.ptr)
    result
end


## Factorizations ##################################################
function dense_matrix_LU(mat::CDenseMatrix)
    ## need square?
    L = CDenseMatrix()
    U = CDenseMatrix()
    ccall((:dense_matrix_LU, libsymengine), Nothing, (Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}), L.ptr, U.ptr,  mat.ptr)
    (L, U)
end

## LDL decomposition
function dense_matrix_LDL(mat::CDenseMatrix)
    L = CDenseMatrix()
    D = CDenseMatrix()
    ccall((:dense_matrix_LDL, libsymengine), Nothing, (Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}), L.ptr, D.ptr,  mat.ptr)
    (L, D)
end

##  Fraction free LU factorization
function dense_matrix_FFLU(mat::CDenseMatrix)
    LU = CDenseMatrix()
    ccall((:dense_matrix_FFLU, libsymengine), Nothing, (Ptr{Cvoid}, Ptr{Cvoid}), LU.ptr, mat.ptr)
    LU
end

## Fraction free LDU factorization
function dense_matrix_FFLDU(mat::CDenseMatrix)
    L = CDenseMatrix()
    D = CDenseMatrix()
    U = CDenseMatrix()
    
    ccall((:dense_matrix_FFLDU, libsymengine), Nothing, (Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}), L.ptr, D.ptr, U.ptr, mat.ptr)
    (L, D, U)
end

function dense_matrix_LU_solve(A::CDenseMatrix, b::CDenseMatrix)
    x = CDenseMatrix()
    ccall((:dense_matrix_LU_solve, libsymengine), Nothing, (Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}), x.ptr, A.ptr, b.ptr)
    x
end


function dense_matrix_zeros(::Type{CDenseMatrix}, r::Int, c::Int)
    result = CDenseMatrix()
    ccall((:dense_matrix_zeros, libsymengine), Nothing, (Ptr{Cvoid}, UInt, UInt), result.ptr, UInt(r), UInt(c))
    result
end


function dense_matrix_ones(r::Int, c::Int)
    result = CDenseMatrix()
    ccall((:dense_matrix_ones, libsymengine), Nothing, (Ptr{Cvoid}, UInt, UInt), result.ptr, UInt(r), UInt(c))
    result
end

## dense_matrix_diag XXX don't have CVecBasic constructor

function dense_matrix_eye(N::Int, M::Int, k::Int=0)
    s = CDenseMatrix()
    ccall((:dense_matrix_eye, libsymengine), Nothing, (Ptr{Cvoid}, UInt, UInt, Int), s.ptr, UInt(N), UInt(M), k)
    s
end

dense_matrix_eq(a::CDenseMatrix, b::CDenseMatrix) = ccall((:dense_matrix_eq, libsymengine), Int, (Ptr{Cvoid},Ptr{Cvoid}), a.ptr, b.ptr)

## Plug into Julia's interface ##################################################

import Base: ==
==(a::CDenseMatrix, b::CDenseMatrix)  = dense_matrix_eq(a, b) == 1

## Abstract Array Interface
Base.size(s::CDenseMatrix) = (dense_matrix_rows(s), dense_matrix_cols(s))
Base.getindex(s::CDenseMatrix, r::Int, c::Int) = dense_matrix_get_basic(s, r-1, c-1)
Base.setindex!(s::CDenseMatrix, val, r::Int, c::Int) = dense_matrix_set_basic(s, val, r-1, c-1)

## special matrices
Base.zeros(::Type{CDenseMatrix}, r::Int, c::Int) = dense_matrix_zeros(s, r-1, c-1)
Base.ones(::Type{CDenseMatrix}, r::Int, c::Int) = dense_matrix_ones(r-1, c-1)


## basic functions
LinearAlgebra.det(s::CDenseMatrix) = dense_matrix_det(s)
LinearAlgebra.det(s::Array{Basic,2}) = dense_matrix_det(CDenseMatrix(s))
Base.inv(s::CDenseMatrix) = dense_matrix_inv(s)
Base.inv(s::Array{Basic,2}) =  Array{Basic,2}(dense_matrix_inv(CDenseMatrix(s)))
Base.transpose(s::CDenseMatrix) = dense_matrix_transpose(s)
Base.transpose(s::Array{Basic,2}) = Array{Basic,2}(dense_matrix_transpose(CDenseMatrix(s)))

LinearAlgebra.factorize(M::CDenseMatrix) = factorize(convert(Matrix, M))

"""
LU decomposition for CDenseMatrix, dense matrices of symbolic values

Also: `lufact(a, Val{:false})` for non-pivoting lu factorization
"""
function LinearAlgebra.lu(a::CDenseMatrix)
    l, u = dense_matrix_LU(a)
    L, U = convert(Matrix, l), convert(Matrix, u)
    n = size(L, 1)
    L[1:n+1:end] .-= one(eltype(L))
    return LinearAlgebra.LU(L + U, collect(1:n), 0)
end
LinearAlgebra.lu(a::Array{Basic,2}) = LinearAlgebra.lu(CDenseMatrix(a))


# solve using LU_solve
import Base: \
\(A::CDenseMatrix, b::CDenseMatrix) = dense_matrix_LU_solve(A, b)
\(A::CDenseMatrix, b::Vector) = A \ convert(CDenseMatrix, [convert(Basic,u) for u in b])
    

using Test
using SymEngine
import LinearAlgebra: lu, det, zeros, dot
CDenseMatrix = SymEngine.CDenseMatrix

@vars x y

# constructors
A = [x 1 2; 3 x 4; 5 6 x]
M = convert(CDenseMatrix, A)
M = CDenseMatrix(A)

# abstract interface
@test M[1,1] == A[1,1]
for i in eachindex(M)
    @test M[i] == A[i]
end
M[1,1] = x^2
@test M[1,1] == x^2
M[1,1] = x

# inherits from DenseArray
@test all(M .+ 3 .== A .+ 3)
@test all(M * 3 .== A * 3)
@test all(M + M .== A + A)
@test all(M * M .== A * A)
@test all(transpose(M) .== transpose(A))

# generic det
@test prod([subs(det(M) - det(A), x, i) == 0 for i in 2:10]) == true
@test inv(M) - inv(A) == zeros(Basic, 3,3)

# factorizations
L1, U1 = lu(M)
L2, U2, P2 = lu(A)
@test iszero(expand.(L1 - L2))
@test iszero(expand.(U1 - U2))

A = [x 1 2; 0 x 4; 0 0 x]
b = [1, 2, 3]
M = convert(CDenseMatrix, A)
out = M \ b
@test M * out - b == zeros(Basic, 3, 1)

@test SymEngine.dense_matrix_eye(2,2,0) == Basic[1 0; 0 1]

# dot product
@test dot(x, x) == x^2
@test dot([1, x, 0], [y, -2, 1]) == y - 2x

@testset "dense matrix" begin
    @vars a b c d x y
    A = [a b; c d]
    B = [x, y]
    res = A \ B
    @test res == [(x - b*(y - c*x/a)/(d - b*c/a))/a,
           (y - c*x/a)/(d - b*c/a)]
end

# SymEngine.jl Documentation

## About
This site contains the documentation and `julia` language bindings for the [Symengine project](https://symengine.org).

### Contents
```@contents
```

## Installation
The package and dependencies can be obtained with standard `Pkg` calls.

```julia-repl
julia> Pkg.add("SymEngine")
```

## License

`SymEngine.jl` is licensed under the MIT open source license.

# Basic usage

Julia wrappers for [SymEngine](https://github.com/symengine/symengine), a fast symbolic manipulation library, written in C++.

To begin, we load the package, as any other:

```@example symengine
using SymEngine
```

## Working with scalar variables

### Defining variables

One can define variables in a few ways. For interactive use, the `@vars` macro proves useful, creating the variable(s) in the local scope:

```@example symengine
@vars a b
```

The `@vars` macro can also be used to define collections of variables and symbolic functions.

The `symbols` constructor can be used as well, it takes a symbol or string and returns a symbolic variable with the expected name. A string with spaces is split to allow the specification of multiple variables.

```@example symengine
a = symbols(:a)
b = symbols(:b)
nothing # hide
```

```@example symengine
a,b = symbols("a b")
```


### Symbolic expressions

Symbolic expressions are built up from symbolic variables and numbers by calling many generic Julia functions.

This command defines an expression using the variables from earlier:

```@example symengine
ex1 = a + 2(b+2)^2 + 2a + 3(a+1)
```

One can see that like values are grouped, but no expansion is done.



#### Mathematical operations

The last example shows that the basic math operations have methods to work with symbolic expressions. The same is the case for many of Julia's generic [mathematical operations](https://docs.julialang.org/en/v1/manual/mathematical-operations/).

```@example symengine
@vars x
ex = sin(x)^2 - x*tanh(exp(x))
```

#### The `Basic` type

The `Basic` type is a wrapper that holds a pointer to the underlying symengine object. In the examples above, both `x`, a variable, and `ex`, an expression, are of type `Basic`, though `x` has an internal type `:Symbol` and `ex` an internal type `:Add`. The `Basic` type constructor can also be used for the construction of numeric symbols, numeric expressions, and numeric numbers. For example,

```@example symengine
n = Basic(10)
```


## Working with vector and matrix variables

### The `@vars` macro

The `@vars` macro allows indexing notation to define vectors or more general arrays:

```@example symengine
@vars x[1:2] A[1:2, 1:2]
```

Indices may have offsets

```@example symengine
@vars y[-2:2]
```

The indices passed to `@vars` must be numeric literals.

### Using `symbols`

A vector of variables can also be defined using list comprehension and string interpolation. This allows for runtime-determination of size:

```@example symengine
n = 4
[symbols("α_$i") for i in 1:n]
```

One can also use a matrix comprehension and string interpolation to create matrices:

```@example symengine
W = [symbols("W_$(i)_$(j)") for i in 1:3, j in 1:4]
```

### Matrix-vector multiplication

The above create Julia vectors and  matrices with symbolic components. The usual generic matrix operations can be employed. For example:


```@example symengine
@vars x[1:2] A[1:3,1:2]
A * x
```

### The `CDenseMatrix` class

The `symengine` library provides a method for LU decomposition. It can be called on a matrix of `Basic` values, which is converted to an internal `CDenseMatrix` type that can be passed to the underlying symengine function.

```@example symengine
@vars a x
A = [x (1 + a*x); x (1+a^2*x)]
using LinearAlgebra
lu(A)
```

Linear symbolic equations can be solved using `\`:

```@example symengine
@vars A[1:2, 1:2] x[1:2]
A \ x
```

Again, this dispatches to a symengine call.

An inverse can be found

```@example symengine
@vars x
A = [1 x; 2 x^2]
inv(A)
```

as can determinants, transposes, and adjoints

```@example symengine
det(A)
```

```@example symengine
A = [im x; 2im x^2]
transpose(A)
```

```@example symengine
A'
```

## Symbolic operations

### `as_numer_denom`, `coeff`

The function `as_numer_denom` takes a fractional expression and returns the numerator and denominator:

```@example symengine
@vars x y
ex = (exp(x) - 1) / x
SymEngine.as_numer_denom(ex)
```

The `coeff` function returns the coefficient of specific power of a symbolic variable:

```@example symengine
@vars a b c x
p = a + b*x + c*x^2
[SymEngine.coeff(p, x, i) for i in 0:2]
```

### `expand`

The `expand` method is used to multiply out terms in a product:

```@example symengine
expand(a + 2(b+2)^2 + 2a + 3(a+1))
```

The `expand`ed expression collects like terms, so may lead to a simplification:

```@example symengine
expand((x + 1)*(x - 2) - (x - 1)*x)
```

The `expand` function is much more performant than that in `Symbolics` -- this function, returning 8436 summands, runs about five times faster:

```@example symengine
function expand_test(a,b,c)
    x = expand(((a+b+c+1)^20))
    y = expand(((a+b+c+1)^15))
    z = expand(x*y)
end
nothing # hide
```


### `subs`

The `subs` methods allows for substitution of parts of the expression tree with other expressions:

```@example symengine
subs(a^2 + (b-2)^2, b=>a)
```

```@example symengine
subs(a^2 + (b-2)^2, b=>2)
```

```@example symengine
subs(a^2 + (b-2)^2, a=>2)
```

```@example symengine
subs(a^2 + (b-2)^2, a^2=>2)
```

```@example symengine
subs(a^2 + (b-2)^2, a=>2, b=>3)
```

The `k=>v` pair notation is used to specify what is to be substituted (`k`) and with what (`v`). As seen, both can be expressions and not just variables.

The `call` method for symbolic expressions dispatches to `subs` and can be called with pairs, as above, or just values. When just values are passed, they are paired with the values returned by `free_symbols`:

```@example symengine
@vars x y z
ex = x * y^2 * z^3
ex(2,3,4) == ex(x=>2, y=>3, z=>4) == ex(Pair.(free_symbols(ex), (2,3,4))...)
```

### `diff`

The `diff` function performs symbolic differentiation.

```@example symengine
diff(a + 2(b+2)^2 + 2a + 3(a+1), b)
```

Higher-order derivatives can be specified with a number

```@example symengine
@vars x
ex = sin(sin(x))
diff(ex, x, 3)
```

Mixed derivatives can be found:

```@example symengine
@vars a b x y
ex = a*x*y^2 + b*x^2*y
diff(ex, x, x, y) # also diff(ex, x, 2, y 1) does 2 in x one in y
```


Symbolic functions can be defined and differentiated

```@example symengine
@vars x f()
diff(f(x), x)
```

The derivative operation in `SymEngine` is more performant than that from `Symbolics` -- this function, which returns 744 summands, for `D=diff` is orders of magnitude faster than for `D=Symbolics.derivative`:

```@example symengine
function diff_test(D, x)
    expr = sin(sin(sin(sin(x))));
    for i = 1:10
        expr = D(expr, x)
    end
    expr
end
nothing # hide
```




## Numeric values

There are a number of built-in constants holding symbolic values including: `PI`, `E`, `IM`, `oo`, `zoo`, `NAN`.

As well, symbolic numbers may be produced through substitution or directly through the `Basic` constructor:

```@example symengine
x = Basic(1)
x/2
```

To convert a symbolic value to a value in `julia` can be done through the `N` function, which attempts to identify a matching type:

```@example symengine
N(x), N(x/2), N(PI)
```

The `float` method will convert the symbolic value to a floating point number:

```@example symengine
float(x), float(x/2), float(PI)
```

The `SymEngine.evalf` function does this conversion within symengine, whereas `float` first attempts to identify an appropriate Julia type through a call to `N` before then calling `float`.

To create a Julia function from an expression it is possible to use something like `x -> float(ex)`, but more idiomatically, `lambdify` would be used:

```@example symengine
@vars x
ex = x * tanh(exp(x))
l = lambdify(ex)
typeof(ex(1)), typeof(l(1))
```

The recipe for `Plots` just wraps an expression with `lambdify`.


Other generic methods in Julia work on symbolic numbers, but not expressions, including: `real`, `imag`, `trunc`, and `round`. For some numeric expressions, first calling `N` then calling one of these functions is needed.


## Introspection

There are various methods allowing the introspection of symbolic values

* `SymEngine.is_constant(ex)` checks if the expression contains any free symbol; return `false` if so.

* `SymEngine.has_symbol(ex,x)` checks if symbolic expression contains the specific symbol.

* `free_symbols(ex)` returns all the symbols in an expression. The `SymEngine.function_symbols` returns symbolic functions, such as defined by `@vars f()`.

* `SymEngine.get_args(ex)` returns the arguments of a given expression; returning an empty vector if the expression has no arguments.

* There are several predicate functions for checking the storage type of a symbolic number: `SymEngine.is_a_Number`, `SymEngine.is_a_Integer`,  `SymEngine.is_a_Rational`, `SymEngine.is_a_RealDouble`, `SymEngine.is_a_RealMPFR`, `SymEngine.is_a_Complex`, `SymEngine.is_a_ComplexDouble`, `SymEngine.is_a_ComplexMPC`. Importantly, these do not apply to a constant symbolic expression. That is, a test like `SymEngine.is_a_Number(1 + exp(Basic(1)))` will be `false`.

* Several generic predicate functions, `iszero`, `isone`, `isinteger`, `isreal`, `isfinite`, `isinf`, and `isnan`.

These are imperfect; it may be better to use `N` to return a numeric value in Julia and call their counterpart. Even then, symbolic numeric expressions may be subject to floating point roundoff that masks the true mathematical nature.

There are also methods to inspect the type that symengine uses to store an expression.

* `SymEngine.get_type` returns an unsigned integer uniquely identifying the type

* `SymEngine.get_symengine_class` returns a symbol representing the top-most operation or storage type of the object in symengine.

* `SymEngine.get_julia_class` returns a symbol representing the Julia type of the top-most operation or storage type of the object in symengine.

If `TermInterface` is loaded (below), the `operation` method returns the outermost function for a given expression.


##  Basic variables are mutable

The `Basic` type is a Julia type wrapping an underlying symengine object. When a Julia method is called on symbolic objects, the method almost always resolves to some call (via `ccall`) into the `libsymengine` C++ library. The design typically involves mutating a newly constructed `Basic` variable. Some allocations can be saved by calling the mutating version of the operations:

```julia
@vars x
a = Basic()
SymEngine.sin!(a, x)
a
```

Other types that may be useful to minimize allocations are `SymEngine.CSetBasic` and `SymEngine.CVecBasic`.

## Use with `TermInterface`

There is an extension for `TermInterface`. The `TermInterface` package allows general symbolic expression manipulation. This example shows how some of the functionality of `subs` can be programmed using the package's interface.

```@example symengine
using TermInterface

function map_matched(x, is_match, f)
    if SymEngine.is_symbol(x)
        return is_match(x) ? f(x) : x
    end

    is_match(x) && return f(x)
    iscall(x) || return x
    children = map_matched.(arguments(x), is_match, f)
    maketerm(Basic, operation(x), children, nothing)
end

replace_exact(ex, p, q) = map_matched(ex, ==(p), _ -> q)

function replace_head(ex, u, v)
    !iscall(ex) && return ex
    args′ = (replace_head(a, u, v) for a ∈ arguments(ex))
    op = operation(ex)
    λ = op == u ? v : op
    ex = maketerm(Basic, λ, args′, nothing)
end
nothing # hide
```

```@example symengine
@vars x u
replace_exact(sin(x^2)*cos(x^2), x^2, u) # subs(ex, p => q)
```

```@example symengine
replace_head(tan(sin(tan(x))), tan, cos)
```

## `SymEngine.jl` and symengine

This package only wraps those parts of symengine that are exposed through its [C wrapper](https://github.com/symengine/symengine/blob/master/symengine/cwrapper.cpp). The underlying C++ library has more functionality.
